com.corticon.eclipse.studio.vocabulary.core

## Interface IVocabularyModelAPI

- All Superinterfaces:
    IModelAPI, com.corticon.rulebuilder.IScopeUtilities, com.corticon.rulebuilder.IVocabularyUtilities
  All Known Subinterfaces:
    IVocabularyTreeModelAPI

      public interface IVocabularyModelAPI
      extends IModelAPI, com.corticon.rulebuilder.IVocabularyUtilities, com.corticon.rulebuilder.IScopeUtilities

  The Vocabulary Model API provides a standardized interface for querying and manipulating Vocabulary metadata. The API uses wrappers for key ecore Vocabulary elements including EClass, EAttribute and EReference.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ANNOTATION_URI_VOCABULARY_EXTENSION` String representing Vocabulary URI Extension.
    `static java.lang.String` | `ASSOCIATION_CARDINALITIES_MANY_TO_MANY`
    `static java.lang.String` | `ASSOCIATION_CARDINALITIES_MANY_TO_ONE`
    `static java.lang.String` | `ASSOCIATION_CARDINALITIES_ONE_TO_MANY`
    `static java.lang.String` | `ASSOCIATION_CARDINALITIES_ONE_TO_ONE`
    `static java.lang.String` | `DOMAIN_SEPARATOR`
    `static int` | `ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY` Vocabulary icon identifiers: Association (many-to-many)
    `static int` | `ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY_LIGHT` Vocabulary icon identifiers: Association (many-to-many light)
    `static int` | `ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE` Vocabulary icon identifiers: Association (many-to-one)
    `static int` | `ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE_LIGHT` Vocabulary icon identifiers: Association (many-to-one light)
    `static int` | `ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY` Vocabulary icon identifiers: Association (one-to-many)
    `static int` | `ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY_LIGHT` Vocabulary icon identifiers: Association (one-to-many light)
    `static int` | `ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE` Vocabulary icon identifiers: Association (one-to-one)
    `static int` | `ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE_LIGHT` Vocabulary icon identifiers: Association (one-to-one light)
    `static int` | `ICON_VOCABULARY_ATTRIBUTE` Vocabulary icon identifiers: Attribute.
    `static int` | `ICON_VOCABULARY_ATTRIBUTE_EXTENDED_PERSISTENT` Vocabulary icon identifiers: Attribute (extended persistent).
    `static int` | `ICON_VOCABULARY_ATTRIBUTE_EXTENDED_TRANSIENT` Vocabulary icon identifiers: Attribute (extended transient).
    `static int` | `ICON_VOCABULARY_DOMAIN` Vocabulary icon identifiers: Domain.
    `static int` | `ICON_VOCABULARY_ENTITY` Vocabulary icon identifiers: Entity.
    `static int` | `ICON_VOCABULARY_ROOT` Vocabulary icon identifiers: Root.
    `static java.lang.String` | `VOCABULARY_SOURCE_OE` Vocabulary source OpenEdge.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `IAssociationEnd` | `addAssociation(AssociationParameters aAssociationParameters)` Add a new association to the Vocabulary as specified in an AssociationParameters instance.
    `IAttribute` | `addAttribute(IEntity aIEntity)` Add a new attribute to the specified entity.
    `IAttribute` | `addAttribute(IEntity aIEntity, IAttribute attributeSource, java.lang.String attributeName)` Add a new attribute to the specified entity, copied from the supplied attribute.
    `com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType` | `addCustomDataType()` Add a new CustomDataType instance to the Vocabulary.
    `com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty` | `addDatabaseProperty()` Add a new DatabaseProperty instance to the Vocabulary.
    `IDomain` | `addDomain()` Add a new domain node to the Vocabulary.
    `IDomain` | `addDomain(IDomain aIDomain)` Add a new domain node to the Vocabulary.
    `IEntity` | `addEntity()` Add a new entity to the Vocabulary.
    `IEntity` | `addEntity(IDomain aIDomain)` Add a new entity to the Vocabulary.
    `IEntity` | `addEntity(IDomain aIDomain, IEntity aIEntitySource)` Add a new entity to the Vocabulary and copy features from the given IEntity Source.
    `com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement` | `addEnumerationElement(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType)` Add a new Enumeration Element instance to the specified CustomDataType.
    `boolean` | `clearDatabaseMetadata(boolean abQuiet)` Clear database metadata.
    `boolean` | `clearJavaClassMetadata()` Clear Java Class Metadata.
    `java.lang.String` | `convertNameIfExtendedOperatorOrOperationsName(java.lang.String astrName)` This method will take in astrName and determine if it is a name that matches an existing Extended Operator or Operations Tree name.
    `IDomain` | `createVocabulary(org.eclipse.emf.common.util.URI aURIVocabulary)` Create a new Vocabulary Resource with the specified URI.
    `void` | `deleteVocabulary()` Delete the Vocabulary and remove its respective Resource.
    `IAssociationEnd` | `findAssociation(java.lang.String astrEntityName, java.lang.String astrAssociationName)` Find association in entity matching a given name.
    `IAssociationEnd` | `findAssociation(java.lang.String astrEntityName, java.lang.String astrAssociationName, boolean abDeclaredOnly)` Find association in entity matching a given name.
    `IAssociationEnd` | `findAssociation(java.lang.String astrEntityName, java.lang.String astrAssociationName, boolean abDeclaredOnly, boolean abBase)` Find association in entity matching a given name.
    `IAttribute` | `findAttribute(java.lang.String astrEntityName, java.lang.String astrAttributeName)` Find first attribute in entity matching a given name.
    `IAttribute` | `findAttribute(java.lang.String astrEntityName, java.lang.String astrAttributeName, boolean abDeclaredOnly)` Find first attribute in entity matching a given name.
    `IAttribute` | `findAttribute(java.lang.String astrEntityName, java.lang.String astrAttributeName, boolean abDeclaredOnly, boolean abBase)` Find first attribute in entity matching a given name.
    `com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType` | `findCustomDataType(java.lang.String astrDataTypeName)` Return the CustomDataType instance corresponding the specified name.
    `com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType` | `findCustomDataTypeByGUID(java.lang.String astrGUID)` Finder to return a CustomDataType corresponding to a specified GUID.
    `com.corticon.rulesemf.canonicalvocabularymodel.DatabaseAccess` | `findDatabaseAccess()` Finder for DatabaseAccess instance.
    `IElement` | `findElementByGUID(java.lang.String astrGUID)` Finder to return a Vocabulary element corresponding to a specified GUID.
    `java.util.List<IElement>` | `findElementsBySource(java.lang.String astrSource)` Return a list of all elements in the Vocabulary that have a specified source.
    `IEntity` | `findEntity(java.lang.String astrEntityName)` Find first entity matching a given name.
    `IEntity` | `findEntity(java.lang.String astrEntityName, boolean abBase)` Find first entity matching a given name.
    `com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement` | `findEnumerationElementByGUID(java.lang.String astrGUID)` Finder to return an EnumerationElement corresponding to a specified GUID.
    `IDomain` | `findRoot()` Finder for root IDomain instance.
    `com.corticon.rulesemf.canonicalvocabularymodel.RootExtension` | `findRootExtension()` Finder for RootExtension instance.
    `IAssociationEnd` | `findXMLAssociation(java.lang.String astrEntityName, java.lang.String astrAssociationName)` Find association in entity matching a given XML name.
    `IAssociationEnd` | `findXMLAssociation(java.lang.String astrEntityName, java.lang.String astrAssociationName, java.lang.String astrQualifierType)` Find association in entity matching a given XML name.
    `IAttribute` | `findXMLAttribute(java.lang.String astrEntityName, java.lang.String astrAttributeName)` Find first attribute in entity matching a given XML name.
    `IEntity` | `findXMLEntity(java.lang.String astrXMLEntityName)` Find first entity with a given XML class name.
    `java.util.HashMap` | `generateBusinessObjects()` Generate a set of basic Business Objects from the Vocabulary
    `AssociationParameters` | `getAssociationParametersExisting(IAssociationEnd aIAssociationEnd)` Returns an AssociationParameters instance populated with data from an existing association.
    `AssociationParameters` | `getAssociationParametersNew(IEntity aIEntity)` Returns an AssociationParameters instance populated with default values that are appropriate for a new association.
    `java.lang.String` | `getBaseLanguageCode(com.corticon.rulesemf.common.LanguageCode aLanguageCode)` Return the base locale corresponding to a specified LanguageCode instance.
    `java.lang.String` | `getBaseVocabularyString(java.util.List aListMultiValuedAttribute)` Given a multi-valued attribute of VocabularyString instances, return the "base" value (index zero) if it exists in the specified list; otherwise, return `null`.
    `java.lang.String` | `getCardinalitiesString(IAssociationEnd aIAssociationEnd)` Return the "cardinalities" string representation for a given instance of IAssociationEnd: 1->1 (one-to-one) 1->* (one-to-many) *->1 (many-to-one) *->* (many-to-many)
    `java.lang.String` | `getConvertedAttributeName(java.lang.String astrAttributeName)` This method will take in the astrAttributeName and verify that it conforms to Corticon's naming standards.
    `java.lang.String` | `getConvertedCustomDataTypeLabelName(java.lang.String astrCustomDataTypeLabelName)` This method will take in the astrCustomDataTypeLabelName and verify that it conforms to Corticon's naming standards.
    `java.lang.String` | `getConvertedCustomDataTypeName(java.lang.String astrCustomDataTypeName)` This method will take in the astrCustomDataTypeName and verify that it conforms to Corticon's naming standards.
    `java.lang.String` | `getConvertedDomainName(java.lang.String astrDomainName)` This method will take in the astrDomainName and verify that it conforms to Corticon's naming standards.
    `java.lang.String` | `getConvertedEntityName(java.lang.String astrEntityName)` This method will take in the astrEntityName and verify that it conforms to Corticon's naming standards.
    `java.lang.String` | `getConvertedRoleName(java.lang.String astrRoleName)` This method will take in the astrRoleName and verify that it conforms to Corticon's naming standards.
    `IElement` | `getCurrentVocabularyElement()` Get the "current" Vocabulary element.
    `java.lang.String` | `getDatabaseAccessCatalogFilter()` Get the Database Access section Catalog Filter.
    `java.lang.String` | `getDatabaseAccessDatabaseId()` Get the Database Access section Database ID.
    `java.lang.String` | `getDatabaseAccessDatabaseURL()` Get the Database Access section Database URL.
    `java.lang.String` | `getDatabaseAccessDialect()` Get the Database Access section Dialect.
    `java.lang.String` | `getDatabaseAccessJDBCDriverClass()` Get the Database Access section JDBC driver class name.
    `java.lang.String` | `getDatabaseAccessPassword()` Get the Database Access section Password.
    `java.lang.String` | `getDatabaseAccessPasswordEncrypted()` Get the Database Access section Password, which is encrypted.
    `java.lang.String` | `getDatabaseAccessSchemaFilter()` Get the Database Access section Schema Filter.
    `java.lang.String` | `getDatabaseAccessUsername()` Get the Database Access section Username.
    `java.lang.String` | `getDatabaseAccessUsernameEncrypted()` Get the Database Access section Username, which is encrypted.
    `IDatabaseDefinition` | `getDatabaseDefinition()` Construct and return an instance of the database definition API.
    `IDatabaseMappingAPI` | `getDatabaseMappingAPI()` Construct and return an instance of the database mapping API.
    `IDatabaseMetadataAPI` | `getDatabaseMetadataAPI()` Construct and return an instance of the database metadata API.
    `java.lang.String` | `getDatabaseProperty(java.lang.String astrName)` Get the value of the specified database property.
    `java.lang.String` | `getDefaultIdentityStrategy(IEntity aIEntity)` Return a default identity strategy for a given entity
    `java.lang.String` | `getDefaultIdentityStrategy(java.lang.String astrDefaultIdentityStrategyType)` Return a default identity strategy for a given identity strategy type
    `java.lang.String` | `getDefaultIdentityStrategyType(IEntity aIEntity)` Return a default identity strategy type for a given entity
    `IDomain` | `getDomain()` Deprecated.
    `java.lang.String` | `getEnumerationLabelBasedOnValue(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aDataType, java.lang.String astrValue)` Query the service to receive the label associated with a value of a enumeration type of type name.
    `IElement` | `getFacade(org.eclipse.emf.ecore.ENamedElement aENamedElement)` Return the Vocabulary facade corresponding to the specified EMF object instance.
    `IJavaMappingAPI` | `getJavaMappingAPI()` Construct and return an instance of the Java mapping API.
    `IJavaMetadataAPI` | `getJavaMetadataAPI()` Construct and return an instance of the Java metadata API.
    `java.util.List` | `getListAttributeModes()` Return a list consisting of all attribute mode values (e.g., base, extended transient).
    `java.util.List` | `getListCardinalities(IAssociationEnd aIAssociationEnd)` Return a list of all cardinality choices: 1->1 (one-to-one) 1->* (one-to-many) *->1 (many-to-one) *->* (many-to-many)
    `java.util.List` | `getListDatabaseColumnNames(java.lang.String astrTableName)` Return a list all database column names belonging to a specified database table.
    `java.util.List` | `getListDatabasePropertyNames()` Return a list all database property names.
    `java.util.List<java.lang.String>` | `getListDatabaseServerNames()` Return a localized list of all database server names from the Database Definition API.
    `java.util.List` | `getListDatabaseTableNames()` Return a list all database tables specified in the database metadata.
    `java.util.List` | `getListDataTypeNames()` Return a list of attribute data type names.
    `java.util.List` | `getListDataTypeNamesIncludingCustom()` Return a list of attribute data type names including custom data type names.
    `java.util.List` | `getListDataTypeNamesUnspecified()` Return a list of attribute data type names including unspecified choice.
    `java.util.List` | `getListEntityIdentity(IEntity aIEntity)` Return a list of items needed to populate the entity identity combo box.
    `java.util.List` | `getListEntityIdentity(IEntity aIEntity, boolean abBase)` Return a list of items needed to populate the entity identity combo box.
    `java.util.List` | `getListEntityNames()` Return a list of fully-qualified entity names in the Vocabulary.
    `java.util.List` | `getListEntityNames(boolean abIncludeBlankItem)` Return a list of fully-qualified entity names in the Vocabulary.
    `java.util.List` | `getListEntityNames(boolean abIncludeBlankItem, boolean abBase)` Return a list of fully-qualified entity names in the Vocabulary.
    `java.util.List` | `getListEnumeration(IAttribute aIAttribute, boolean abUnspecified, boolean abNull, boolean abIncludeCustomDataTypeNames)` Return a list from the custom data type enumeration identified by the specified attribute facade.
    `java.util.List` | `getListFieldNullValue()` Return a list of JPOX field:null-value choices.
    `java.util.List` | `getListFieldValueStrategies(IAttribute aIAttribute)` Return a list of JPOX field:value-strategy choices.
    `java.util.List` | `getListIdentityStrategies()` Return a list of identity strategies.
    `java.util.List` | `getListJavaClassNames(java.lang.String astrPackageName)` Return a list of java class names belonging to the specified fully-qualified package name.
    `java.util.List` | `getListJavaObjectFieldNames(IAssociationEnd aIAssociationEnd)` Return a list consisting of java object field names.
    `java.util.List` | `getListJavaObjectFieldNames(IAttribute aIAttribute)` Return a list consisting of java object field names.
    `java.util.List` | `getListJavaObjectGetMethods(IAssociationEnd aIAssociationEnd)` Return a list consisting of java object get method names.
    `java.util.List` | `getListJavaObjectGetMethods(IAttribute aIAttribute)` Return a list consisting of java object get method names.
    `java.util.List` | `getListJavaObjectSetMethods(IAssociationEnd aIAssociaitonEnd)` Return a list consisting of java object set method names.
    `java.util.List` | `getListJavaObjectSetMethods(IAttribute aIAttribute)` Return a list consisting of java object set method names.
    `java.util.List` | `getListJavaPackages()` Return a list of java package names (imported java object metadata).
    `java.util.List` | `getListJoinExpressions(IAssociationEnd aIAssociationEnd)` Get all valid join expressions for a given association end from database metadata.
    `java.util.List` | `getListLocaleNames()` Return a localized list of all locale names (typically used to populate the "Locale" drop-down list in the Localization view.
    `java.util.List` | `getListNavigabilities(IAssociationEnd aIAssociation)` Return a list of all navigability choices.
    `java.util.List` | `getListNavigabilities(java.lang.String astrSourceEntityName, java.lang.String astrSourceToTargetRoleName, java.lang.String astrTargetEntityName, java.lang.String astrTargetToSourceRoleName)` Return a list of all navigability choices.
    `java.util.List` | `getListTrueFalse()` Return a list consisting of values "true" and "false" choices.
    `java.util.List` | `getListTrueFalseUnspecified()` Return a list consisting of values "true", "false" and unspecified choices.
    `java.util.List` | `getListUnqualifiedEntityNames()` Return a list of unqualified entity names in the Vocabulary.
    `java.util.List` | `getListVersionStrategies()` Return a list of version strategies.
    `java.lang.String` | `getLocalDataType(IAttribute aIAttribute)` Return the data type string localized for display, taking custom data types into account.
    `java.lang.String` | `getLocalLanguageCode(com.corticon.rulesemf.common.LanguageCode aLanguageCode)` Return the localized locale corresponding to a specified LanguageCode instance.
    `java.lang.String` | `getLocalString(java.lang.String astrKeyPrefix, java.lang.String astrBaseString)` Convenience method to get the localized value for a corresponding base value.
    `java.lang.String` | `getMessageBase(java.lang.String astrKeyPrefix, java.lang.String astrLocalizedString)` Return the base message corresponding to the specified bundle key.
    `java.lang.String` | `getNavigabilityBidirectional()` Format and return bidirectional navigability string.
    `java.lang.String` | `getNavigabilitySourceToTarget(java.lang.String astrEntityName, java.lang.String astrRoleName)` Format and return source-to-target navigability string.
    `java.lang.String` | `getNavigabilityString(IAssociationEnd aIAssociationEnd)` Return the "navigability" string representation for a given instance of IAssociationEnd.
    `java.lang.String` | `getNavigabilityTargetToSource(java.lang.String astrEntityName, java.lang.String astrRoleName)` Format and return target-to-source navigability string.
    `java.lang.String` | `getNewAttributeName(IEntity aIEntity)` Return a guaranteed-unique attribute name of the form Attribute_ where is a sequence number (starting with 1).
    `java.lang.String` | `getNewDomainName(IDomain aIDomain)` Return a guaranteed-unique domain name of the form Domain_ where is a sequence number (starting with 1).
    `java.lang.String` | `getNewEntityName(IDomain aIDomain)` Return a guaranteed-unique entity name of the form Entity_ where is a sequence number (starting with 1).
    `java.lang.String` | `getNewRoleName(IEntity aIEntitySource, IEntity aIEntityTarget)` Return a guaranteed-unique role name.
    `java.lang.String` | `getNewVocabularyName(org.eclipse.emf.common.util.URI aURIContainer)` Given the URI of a container in the storage system, create a new unique Vocabulary name using sequence numbers if necessary.
    `java.lang.String` | `getNextAvailableAttributeName(IEntity aIEntity, java.lang.String astrAttributeName)` This method will take in the astrAttributeName that is passed in and verify that it is unique in this Entity.
    `AssociationParameters` | `getNextAvailableConvertedAssociationParamaters(AssociationParameters aAssociationParameters)` This method will take in the aAssociationParameters and call into getConvertedName(String) and getNextAvailableAliasName(String)for each role name of the association.
    `java.lang.String` | `getNextAvailableConvertedAttributeName(IEntity aIEntity, java.lang.String astrAttributeName)` This method will take in the astrAttributeName and call into getConvertedAttributeName(String) and getNextAvailableAttributeName(IEntity, String) for the name that was passed into this method.
    `java.lang.String` | `getNextAvailableConvertedCustomDataTypeLabelName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrCustomDataTypeLabelName)` This method will take in the astrCustomDataTypeLabelName and call into getConvertedCustomDataTypeLabelName(String) and getNextAvailableCustomDataTypeLabelName(CustomDataType, String) for the passed in name.
    `java.lang.String` | `getNextAvailableConvertedCustomDataTypeName(java.lang.String astrCustomDataTypeName)` This method will take in the astrCustomDataTypeName and call into getConvertedCustomDataTypeName(String) and getNextAvailableCustomDataTypeName(String) for the name that was passed into this method.
    `java.lang.String` | `getNextAvailableConvertedDomainName(IDomain aIDomain, java.lang.String astrDomainName)` This method will take in the astrDomainName and call into getConvertedDomainName(String) and getNextAvailableDomainName(IDomain, String) for the name that was passed into this method.
    `java.lang.String` | `getNextAvailableConvertedEntityName(IDomain aIDomain, java.lang.String astrEntityName)` This method will take in the astrEntityName and call into getConvertedEntityName(String) and getNextAvailableEntityName(IDomain, String) for the name that was passed into this method.
    `java.lang.String` | `getNextAvailableConvertedRoleName(IEntity aIEntitySource, IEntity aIEntityTarget, java.lang.String astrRoleName)` This method will take in the astrRoleName and call into getConvertedRoleName(String) and getNextAvailableRoleName(IEntity, IEntity, String) for the passed in role name.
    `java.lang.String` | `getNextAvailableCustomDataTypeLabelName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrCustomDataTypeLabelName)` This method will take in the astrCustomDataTypeLabelName that is passed in and verify that it is unique within a passed in custom data type.
    `java.lang.String` | `getNextAvailableCustomDataTypeName(java.lang.String astrCustomDataTypeName)` This method will take in the astrCustomDataTypeName that is passed in and verify that it is unique.
    `java.lang.String` | `getNextAvailableDomainName(IDomain aIDomain, java.lang.String astrDomainName)` This method will take in the astrDomainName that is passed in and verify that it is unique within a passed in Domain.
    `java.lang.String` | `getNextAvailableEntityName(IDomain aIDomain, java.lang.String astrEntityName)` This method will take in the astrEntityName that is passed in and verify that it is unique within a passed in Domain.
    `java.lang.String` | `getNextAvailableRoleName(IEntity aIEntitySource, IEntity aIEntityTarget, java.lang.String astrRoleName)` This method will take in the astrRoleName that is passed in and verify that it is unique within a passed in source entity.
    `IOperationsModelAPI` | `getOperationsModelAPI()` Return an instance of the Operations model API with its state set identically to *this* API.
    `java.lang.String` | `getOperatorName(java.lang.String astrOperatorID, boolean abBase)` Get the base or localized operator name corresponding to the specified operator ID.
    `java.lang.String` | `getToolTip(IElement lIElement)` Get the tool tip for the specified Vocabulary node.
    `java.lang.String` | `getVocabularyDomainHierarchy(IEntity aIEntity)` Given an IEntity, return a localized Vocabulary domain hierarchy for that entity.
    `java.util.List` | `getVocabularyElementChildren(java.lang.Object aObject, boolean abExpandAssociations, boolean abIncludeInherited, boolean abSort)` Get a list of children of the specified Vocabulary element.
    `int` | `getVocabularyElementIcon(IElement aIElement)` Given an IElement instance, return an integer constant corresponding to the icon to be displayed in the Vocabulary tree viewer (e.g., IVocabularyModelAPI.ICON_VOCABULARY_ENTITY).
    `java.lang.String` | `getVocabularyElementName(IElement aIElement)` Given an IElement, return a localized element name.
    `java.lang.String` | `getVocabularyElementName(IElement aIElement, boolean abBase)` Given an IElement, return an element name.
    `java.lang.String` | `getVocabularyElementNameBase(IElement aIElement)` Deprecated. Use getVocabularyElementName(aIElement, abBase) instead.
    `java.lang.String` | `getVocabularyElementNameHierarchy(IElement aIElement, boolean abBase)` Given an IElement return a unique base or localized name for that element.
    `java.lang.Object` | `getVocabularyElementParent(java.lang.Object aObject)` Return the parent of the specified Vocabulary element.
    `java.lang.String` | `getVocabularyElementSuffix(IEntity aIEntity, boolean abAssociationFormat, boolean abBase)` Return the appropriate localized suffix for a given Vocabulary entity.
    `java.lang.String` | `getVocabularyElementText(IElement aObject, boolean abBase)` Given a Vocabulary element (facade), return text to be displayed adjacent to the specified node in the Vocabulary tree.
    `boolean` | `hasDatabase(IElement aIElement)` Return true if the Vocabulary Element is database bound and should be represented in the tree with a database decoration.
    `boolean` | `hasErrors(IElement aIElement, boolean abRecursive)` Return true if the Vocabulary Element has any validation errors.
    `boolean` | `hasErrors(IElement aIElement, boolean abRecursive, boolean abIncludeInherited)` Return true if the Vocabulary Element has any validation errors.
    `boolean` | `hasModified(IElement aIElement)` Return true if the Vocabulary Element is should be be represented with the modified icon decoration.
    `boolean` | `hasWarnings(IElement aIElement, boolean abRecursive)` Return true if the Vocabulary Element has any validation warnings.
    `boolean` | `hasWarnings(IElement aIElement, boolean abRecursive, boolean abIncludeInherited)` Return true if the Vocabulary Element has any validation warnings.
    `boolean` | `importDatabaseMetadata(boolean abQuiet)` Import the database metadata.
    `java.lang.String` | `importJavaMetadata(java.util.Collection<java.lang.String> acollClassNames, java.util.List<java.lang.String> alistPaths, IProgressDelegate aIProgressDelegate)` Import Java class metadata corresponding to a collection of fully-qualified class names.
    `boolean` | `isCreateUpdateSchemaSupported()` Check if the Create/Update schema is supported by the database
    `boolean` | `isDatabaseAccessEnabled()` Method to return an indication of whether database access support is enabled.
    `boolean` | `isDatabaseAccessSpecified()` Method to return an indication of whether the Vocabulary has database access fields specified.
    `boolean` | `isEnabledAddAssociation(Selection aSelection)` Determine whether Add Association function is enabled.
    `boolean` | `isEnabledAddAttribute(Selection aSelection)` Determine whether Add Attribute function is enabled.
    `boolean` | `isEnabledAddDomain(Selection aSelection)` Determine whether Add Domain function is enabled.
    `boolean` | `isEnabledAddEntity(Selection aSelection)` Determine whether Add Entity function is enabled.
    `boolean` | `isEnabledClearDatabaseMetadata()` Determine whether Clear Database Metadata function is enabled.
    `boolean` | `isEnabledClearJavaClassMetadata()` Determine whether Clear Java Class Metadata function is enabled.
    `boolean` | `isEnabledExportDatabaseAccessProperties()` Determine whether Export Database Access Properties function is enabled.
    `boolean` | `isEnabledImportDatabaseMetadata()` Determine whether Import Database Metadata function is enabled.
    `boolean` | `isEnabledImportJavaClassMetadata(Selection aSelection)` Determine whether Import Java Class Metadata function is enabled.
    `boolean` | `isEnabledLocalize()` Determine whether Localize function is enabled.
    `boolean` | `isEnabledReadOnlyReadWrite()` Check if the the Vocabulary is set in ReadOnly or ReadWrite mode
    `boolean` | `isEntityNameAlreadyUsed(java.lang.String astrEntityName)` Determine whether this name matches any entity name in the Vocabulary.
    `boolean` | `isInheritedFeature(IEntity aIEntity, IElement aIElementFeature)` Returns `true` if the given Vocabulary element (attribute or association) is an inherited feature of the specified entity.
    `boolean` | `isNameExtendedOperatorOrOperationsName(java.lang.String astrName)` Check to see if this particular name conflicts with a name in the Operations Tree or an Extended Operator
    `boolean` | `isReadOnlyModeSupported()` Check if the Read Only mode is supported by the database
    `boolean` | `isRoleNameUsed(IEntity aIEntity, java.lang.String astrRoleName)` Determine whether the specified role name is currently in use within the specified Entity.
    `boolean` | `isVocabularyElementInherited(IElement aIElement)` Deprecated. Use isVocabularyElementNameLightGray instead.
    `boolean` | `isVocabularyElementNameLightGray(IElement aIElement)` Determine whether the specified Vocabulary element name should be rendered in light gray text.
    `boolean` | `isVocabularyEntityNameUnique(IEntity aIEntity, boolean abBase)` Determine whether the name of the specified entity would be ambiguous if it were not for its domain qualification (i.e., the unqualified entity name is used by more than one Vocabulary entity).
    `IDomain` | `makeDomain(org.eclipse.emf.ecore.EPackage aEPackage)` Factory method to create a new IDomain facade from a given EPackage.
    `com.corticon.rulesemf.canonicalvocabularymodel.VocabularyBoolean` | `makeVocabularyBoolean(java.lang.String astrValue)` Factory method to create a valid, manually-created VocabularyBoolean from a string.
    `com.corticon.rulesemf.canonicalvocabularymodel.VocabularyDataType` | `makeVocabularyDataType(java.lang.String astrValue)` Factory method to create a valid, manually-created VocabularyDataType from a string.
    `com.corticon.rulesemf.canonicalvocabularymodel.VocabularyExpression` | `makeVocabularyExpression(java.lang.String astrValue)` Factory method to create a valid, manually-created VocabularyExpression from a string.
    `com.corticon.rulesemf.canonicalvocabularymodel.VocabularyString` | `makeVocabularyString(java.lang.String astrValue)` Factory method to create a valid, manually-created VocabularyString from a string.
    `com.corticon.rulesemf.canonicalvocabularymodel.VocabularyValueSet` | `makeVocabularyValueSet(java.lang.String astrValue)` Factory method to create a valid, manually-created VocabularyValueSet from a string.
    `boolean` | `removeCustomDataType(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType)` Remove the specified CustomDataType from the list.
    `boolean` | `removeDatabaseProperty(com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty aDatabaseProperty)` Remove a DatabaseProperty from the list.
    `boolean` | `removeEnumerationElement(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement)` Remove an EnumerationElement from the specified CustomDataType.
    `java.lang.Object` | `removeFromEntity(java.lang.Object object)` Remove attribute or association from the entity.
    `boolean` | `removeVocabularyElement(IElement aIElement)` Remove an element from the Vocabulary.
    `boolean` | `renameVocabulary(org.eclipse.emf.common.util.URI aURIVocabularyNew)` Rename the specified Vocabulary.
    `boolean` | `replaceAssociation(IAssociationEnd aIAssociationEnd, AssociationParameters aAssociationParameters)` Replace (update) an existing association.
    `boolean` | `setAssociationEndCardinalities(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Cardinalities.
    `boolean` | `setAssociationEndJavaObjectFieldName(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Java Object Field Name.
    `boolean` | `setAssociationEndJavaObjectGetMethod(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Java Object Get Method.
    `boolean` | `setAssociationEndJavaObjectSetMethod(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Java Object Set Method.
    `boolean` | `setAssociationEndJoinExpression(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Join Expression.
    `boolean` | `setAssociationEndMandatory(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Mandatory.
    `boolean` | `setAssociationEndName(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd name.
    `boolean` | `setAssociationEndNavigability(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Navigability.
    `boolean` | `setAssociationEndSourceEntity(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Source Entity.
    `boolean` | `setAssociationEndTargetEntity(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd Target Entity.
    `boolean` | `setAssociationEndXMLPropertyName(IAssociationEnd aIAssociationEnd, java.lang.String astrValue)` Set AssociationEnd XML Property Name.
    `boolean` | `setAttributeDataSubtype(IAttribute aIAttribute, java.lang.String astrValue)` Deprecated. Subtypes are now handled as real data types (use method setAttributeDataType instead).
    `boolean` | `setAttributeDataType(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute data type.
    `boolean` | `setAttributeFieldColumn(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute field:column property.
    `boolean` | `setAttributeFieldSequence(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute field:sequence property.
    `boolean` | `setAttributeFieldSequenceNameColumnName(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute field:sequence-name-column-name property.
    `boolean` | `setAttributeFieldSequenceNextvalColumnName(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute field:sequence-nextval-column-name property.
    `boolean` | `setAttributeFieldSequenceTableName(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute field:sequence-table-name property.
    `boolean` | `setAttributeFieldValueStrategy(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute field:value-strategy property.
    `boolean` | `setAttributeJavaObjectFieldName(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute Java Object Field Name.
    `boolean` | `setAttributeJavaObjectGetMethod(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute Java Object Get Method.
    `boolean` | `setAttributeJavaObjectSetMethod(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute Java Object Set Method.
    `boolean` | `setAttributeMandatory(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute mandatory flag.
    `boolean` | `setAttributeMode(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute mode.
    `boolean` | `setAttributeName(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute name.
    `boolean` | `setAttributePossibleValues(IAttribute aIAttribute, java.lang.String astrValue)` Deprecated. This method should only be used by Corticon. This is used in the 4.x to 5.0 Vocabulary conversion
    `boolean` | `setAttributePossibleValueSetName(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute possible values set name.
    `boolean` | `setAttributeXMLNamespace(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute XML Namespace.
    `boolean` | `setAttributeXMLPropertyName(IAttribute aIAttribute, java.lang.String astrValue)` Set Attribute XML Property Name.
    `boolean` | `setCurrentVocabularyElement(IElement aIElement)` Set the "current" Vocabulary element.
    `boolean` | `setCustomDataTypeBaseDataType(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrValue)` Sets the Custom data type base data type.
    `boolean` | `setCustomDataTypeConstraint(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrValue)` Sets the Custom data type constraint expression.
    `boolean` | `setCustomDataTypeEnumeration(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrValue)` Sets the Custom data type enumeration flag.
    `boolean` | `setCustomDataTypeLookupLabelsColumn(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrValue)` Sets the Custom data type lookup labels column.
    `boolean` | `setCustomDataTypeLookupTableName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrValue)` Sets the Custom data type lookup table name.
    `boolean` | `setCustomDataTypeLookupValuesColumn(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrValue)` Sets the Custom data type lookup values column.
    `boolean` | `setCustomDataTypeName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrValue)` Sets the Custom data type name.
    `boolean` | `setDatabaseAccessCatalogFilter(java.lang.String astrValue)` Set the Database Access section catalog filter.
    `boolean` | `setDatabaseAccessDatabaseId(java.lang.String astrValue)` Set the Database Access section Database ID.
    `boolean` | `setDatabaseAccessDatabaseURL(java.lang.String astrValue)` Set the Database Access section Database URL.
    `boolean` | `setDatabaseAccessPassword(java.lang.String astrValue)` Set the Database Access section Password.
    `boolean` | `setDatabaseAccessSchemaFilter(java.lang.String astrValue)` Set the Database Access section schema filter.
    `boolean` | `setDatabaseAccessUsername(java.lang.String astrValue)` Set the Database Access section Username.
    `boolean` | `setDatabasePropertyName(com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty aDatabaseProperty, java.lang.String astrValue)` Sets the database property name.
    `boolean` | `setDatabasePropertyValue(com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty aDatabaseProperty, java.lang.String astrValue)` Sets the database property value.
    `boolean` | `setDomainName(IDomain aIDomain, java.lang.String astrValue)` Set Domain name.
    `void` | `setEnabledReadOnlyReadWrite(boolean abReadOnlyReadWrite)` Set Vocabulary ReadOnly or ReadWrite mode
    `boolean` | `setEntityClassTable(IEntity aIEntity, java.lang.String astrValue)` Set Entity class:table property.
    `boolean` | `setEntityDatastoreCaching(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore caching indicator.
    `boolean` | `setEntityDatastoreIdentityColumn(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore-identity:column property.
    `boolean` | `setEntityDatastoreIdentitySequence(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore-identity:sequence property.
    `boolean` | `setEntityDatastoreIdentitySequenceNameColumnName(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore-identity:sequence-name-column-name property.
    `boolean` | `setEntityDatastoreIdentitySequenceNextvalColumnName(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore-identity:sequence-nextval-column-name property.
    `boolean` | `setEntityDatastoreIdentitySequenceTableName(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore-identity:sequence-table-name property.
    `boolean` | `setEntityDatastoreIdentityStrategy(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore-identity:strategy property.
    `boolean` | `setEntityDatastorePersistent(IEntity aIEntity, java.lang.String astrValue)` Set Entity datastore-persistent indicator.
    `boolean` | `setEntityIdentity(IEntity aIEntity, java.lang.String astrValue)` Set Entity Identity.
    `boolean` | `setEntityJavaClassName(IEntity aIEntity, java.lang.String astrValue)` Set Entity Java Class name.
    `boolean` | `setEntityJavaPackage(IEntity aIEntity, java.lang.String astrValue)` Set Entity Java Package.
    `boolean` | `setEntityName(IEntity aIEntity, java.lang.String astrValue)` Set Entity name.
    `boolean` | `setEntitySupertypes(IEntity aIEntity, java.util.List aListEntities)` Set Entity Supertype(s) given a list of IEntity facades.
    `boolean` | `setEntitySupertypes(IEntity aIEntity, java.lang.String astrValue)` Set Entity Supertype(s).
    `boolean` | `setEntityVersionColumn(IEntity aIEntity, java.lang.String astrValue)` Set Entity version:column property.
    `boolean` | `setEntityVersionStrategy(IEntity aIEntity, java.lang.String astrValue)` Set Entity version:strategy property.
    `boolean` | `setEntityXMLClassName(IEntity aIEntity, java.lang.String astrValue)` Set Entity XML Class name.
    `boolean` | `setEntityXMLNamespace(IEntity aIEntity, java.lang.String astrValue)` Set Entity XML Namespace.
    `boolean` | `setEnumerationLabel(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement, java.lang.String astrValue)` Sets the Enumeration label.
    `boolean` | `setEnumerationValue(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement, java.lang.String astrValue)` Sets the Enumeration value.
    `boolean` | `setGUID(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, java.lang.String astrGUID)` Set the optional GUID associated with the specified custom data type.
    `boolean` | `setGUID(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumeratonElement, java.lang.String astrGUID)` Set the optional GUID associated with the specified enumeration element.
    `boolean` | `setGUID(IElement aIElement, java.lang.String astrGUID)` Set the optional GUID associated with this element.
    `boolean` | `setLocalizationCustomDataTypeName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType, int aiLocalizationIndex, java.lang.String astrText)` Given a CustomDataType instance, update the specified localized custom data type name.
    `boolean` | `setLocalizationEnumerationLabel(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement, int aiLocalizationIndex, java.lang.String astrText)` Given a EnumerationElement instance, update the specified localized enumeration label.
    `boolean` | `setLocalizationVocabularyElementName(IElement aIElement, int aiLocalizationIndex, java.lang.String astrText)` Given a Vocabulary element, update the specified localized element name.
    `boolean` | `setSource(IElement aIElement, java.lang.String astrSource)` Set the optional "source" associated with this element.
    `boolean` | `setVocabularyElementName(IElement aIElement, java.lang.String astrValue)` Set the localized Vocabulary element name according to Native Tongue editing rules.
    `void` | `testDatabaseConnection()` Test the database connection using the database access properties and display a message box if the connection is valid.

    - ### Methods inherited from interface com.corticon.eclipse.core.IModelAPI

      `activate, addAnnotation, addBatchedModelListener, addLowLevelModelListener, addModelListener, addResourceListener, addView, beginTransaction, cancelTransaction, canSetSupportedLocales, closeResource, createResource, deleteAnnotation, deleteAnnotation, deleteAnnotation, deleteResource, displayMessageBox, dispose, doPostLoadValidation, doSmartValidation, endTransaction, endTransaction, flushCommandStack, formatValidationMessageLocation, formatValidationMessageText, getAllLocalesProvidingCompleteLocalization, getAnnotation, getAnnotations, getAnnotations, getAnnotations, getAPIContextObject, getAsset, getBaseAttribute, getBaseAttributeString, getBatchedModelListeners, getBuildNumber, getBuildNumberOfLastValidationRulesChange, getEditingDomain, getErrors, getErrors, getIndexByLocale, getLocale, getLocalizedAttribute, getLocalizedAttributeString, getLowLevelModelListeners, getMajorServiceNumber, getMajorVersionNumber, getMessage, getMessage, getMessageBoxDelegate, getMinorServiceNumber, getMinorVersionNumber, getModelAPIState, getModelListeners, getNewResourceName, getPersistenceServicesDelegate, getPreferences, getPrimaryResource, getPrimaryResourceURI, getScrollableMessageDelegate, getSupportedLocales, getSuppressBrokenLinkValidation, getSuppressValidation, getToolTip, getUpdateStamp, getUserInterfaceInfoDelegate, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessages, getValidationMessages, getWarnings, getWarnings, handleException, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, isAPIStateEstablished, isEnabledRedo, isEnabledUndo, isInhibitNotification, isLoaded, isOperationModeNormal, isOperationModeRedo, isOperationModeUndo, isPassive, isPostLoadInProgress, isPrimaryResourceSet, isReadOnly, isResourceActivated, isResourceConflict, isResourceDemandLoaded, isResourceLoaded, isScrollableMessageDelegateAvailable, isShowCanonicalValidationMessages, isSuppressModifiedFlagUpdates, isSuppressPostLoad, isTransactionInProgress, isValid, isValid, loadResource, loadResource, loadResource, newInstance, noOperation, postLoad, postMethod, postMethod, postsave, preMethod, presave, redo, reloadResource, remapResource, remapResource, removeBatchedModelListener, removeLowLevelModelListener, removeModelListener, removeResource, removeResourceListener, removeView, renameResource, rollbackTransaction, saveAll, saveResource, setAnnotation, setAPIContextObject, setAPIState, setBuildNumber, setEditingDomain, setInhibitNotification, setLocale, setMajorServiceNumber, setMajorVersionNumber, setMessageBoxDelegate, setMinorServiceNumber, setMinorVersionNumber, setModelAPIState, setModelListeners, setPassive, setPersistenceServicesDelegate, setPostLoadInProgress, setPreferencesDelegate, setPrimaryResource, setReadOnly, setScrollableMessageDelegate, setSupportedLocales, setSuppressBrokenLinkValidation, setSuppressModifiedFlagUpdates, setSuppressPostLoad, setSuppressValidation, setUserInterfaceInfoDelegate, undo, unloadResource, validate, validateLicense`

    - ### Methods inherited from interface com.corticon.rulebuilder.IVocabularyUtilities

      `getAllAttributeNamesForEntity, getAllBaseAttributeNamesForEntity, getAllExtAliaeForThisExtEntityType, getAllFullyQualifiedBaseEntityNames, getAllJdoPackages, getAllMissingParentEntityNames, getAllSupertypeEntityNamesForEntity, getArchive, getAssociationEndDataTypeForObjectFieldNameFromMetaDataOrNull, getAssociationEndObjectFieldNameIsArrayToMetaDataOrNull, getAssociationEndObjectFieldToMetaDataOrNull, getAssociationEndObjectGetMethodIsArrayToMetaDataOrNull, getAssociationEndObjectGetMethodToMetaDataOrNull, getAssociationEndObjectGetMethodTypeToMetaDataOrNull, getAssociationEndObjectSetMethodIsArrayToMetaDataOrNull, getAssociationEndObjectSetMethodToMetaDataOrNull, getAssociationEndObjectSetMethodTypeToMetaDataOrNull, getAssociationJavaDataType, getAssociationPrimaryKeysForEntity, getAttributeDataType, getAttributeDataTypeSubType, getAttributeJavaDataType, getAttributeObjectFieldNameOrMetaDataOrNull, getAttributeObjectGetMethodOrMetaDataOrNull, getAttributeObjectSetMethod, getAttributeObjectSetMethodOrMetaDataOrNull, getAttributeXMLName, getAttributeXMLNamespace, getConstraintExpr, getDataTypeForGetMethodCallFromMetaDataOrNull, getDataTypeForObjectFieldNameFromMetaDataOrNull, getDataTypeForSetMethodCallFromMetaDataOrNull, getEntityClassName, getEntityFeatureCount, getEntityFeatureList, getEntityFullyQualifiedCDOInterfaceName, getEntityFullyQualifiedCDOListenerName, getEntityFullyQualifiedCDOName, getEntityIdentityAttributeNamesOrDefault, getEntityIdentityRoleNamesOrDefault, getEntityList, getEntityNamespace, getEntityObjectClassName, getEntityObjectName, getEntityTableName, getEntityXMLName, getEntityXMLNamespace, getEquivalentEntities, getExternalRoleName, getFeatureType, getFilePath, getJavaMetaData, getJdoListenerClassName, getMethodDataType, getMethodParamTypes, getPackageNameForEntity, getPrimaryKeyNamesForEntity, getPrimaryKeysForEntity, getReverseEntityName, getReverseRoleName, getRoleDataType, getRoleList, getRoleMultiplicity, getRoleNavigability, getUnqualifiedClassNameForEntity, isApplicationIdentity, isAssociationFieldAccessed, isAssociationMandatory, isAssociationMethodAccessed, isAttributeEnumeration, isAttributeFieldAccessed, isAttributeGetMethodAccessed, isAttributeMandatory, isAttributeSetMethodAccessed, isAttributeTransient, isBaseAttribute, isBaseDerivedOrExtendedAttribute, isDatastoreIdentity, isDependentFrom, isDervivedAttribute, isEntityByName, isEntityPersisted, isExtendedAttribute, isExternalEntityByName, isIdentityStrategySpecified, isJavaMetaDataClassAnInterface, isPersistentEntity, isPrimaryKeyAttribute, isRoleNavigable, isRoleOfEntity, isValidEntityAttribute, isValidEntityMethod`

    - ### Methods inherited from interface com.corticon.rulebuilder.IScopeUtilities

      `getAttributeDataType, getAttributeDataTypeSubType, getFullyQualifiedEntityName, getLogicalVariablePath, getMethodDataType, getMethodParamTypes, getRoleDataType, getRoleMultiplicity, isAttributeMandatory, isEntityByName, isExternalEntityByName, isRoleOfEntity, isSubTypeOf, isValidEntityAttribute, isValidEntityMethod`

- - ### Field Detail

    - #### ANNOTATION_URI_VOCABULARY_EXTENSION

          static final java.lang.String ANNOTATION_URI_VOCABULARY_EXTENSION

      String representing Vocabulary URI Extension.
      See Also:
        Constant Field Values

    - #### DOMAIN_SEPARATOR

          static final java.lang.String DOMAIN_SEPARATOR

      See Also:
        Constant Field Values

    - #### ASSOCIATION_CARDINALITIES_ONE_TO_ONE

          static final java.lang.String ASSOCIATION_CARDINALITIES_ONE_TO_ONE

      See Also:
        Constant Field Values

    - #### ASSOCIATION_CARDINALITIES_ONE_TO_MANY

          static final java.lang.String ASSOCIATION_CARDINALITIES_ONE_TO_MANY

      See Also:
        Constant Field Values

    - #### ASSOCIATION_CARDINALITIES_MANY_TO_ONE

          static final java.lang.String ASSOCIATION_CARDINALITIES_MANY_TO_ONE

      See Also:
        Constant Field Values

    - #### ASSOCIATION_CARDINALITIES_MANY_TO_MANY

          static final java.lang.String ASSOCIATION_CARDINALITIES_MANY_TO_MANY

      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ROOT

          static final int ICON_VOCABULARY_ROOT

      Vocabulary icon identifiers: Root.
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_DOMAIN

          static final int ICON_VOCABULARY_DOMAIN

      Vocabulary icon identifiers: Domain.
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ENTITY

          static final int ICON_VOCABULARY_ENTITY

      Vocabulary icon identifiers: Entity.
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ATTRIBUTE

          static final int ICON_VOCABULARY_ATTRIBUTE

      Vocabulary icon identifiers: Attribute.
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ATTRIBUTE_EXTENDED_TRANSIENT

          static final int ICON_VOCABULARY_ATTRIBUTE_EXTENDED_TRANSIENT

      Vocabulary icon identifiers: Attribute (extended transient).
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ATTRIBUTE_EXTENDED_PERSISTENT

          static final int ICON_VOCABULARY_ATTRIBUTE_EXTENDED_PERSISTENT

      Vocabulary icon identifiers: Attribute (extended persistent).
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE

          static final int ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE

      Vocabulary icon identifiers: Association (one-to-one)
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY

          static final int ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY

      Vocabulary icon identifiers: Association (one-to-many)
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE

          static final int ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE

      Vocabulary icon identifiers: Association (many-to-one)
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY

          static final int ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY

      Vocabulary icon identifiers: Association (many-to-many)
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE_LIGHT

          static final int ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE_LIGHT

      Vocabulary icon identifiers: Association (one-to-one light)
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY_LIGHT

          static final int ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY_LIGHT

      Vocabulary icon identifiers: Association (one-to-many light)
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE_LIGHT

          static final int ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE_LIGHT

      Vocabulary icon identifiers: Association (many-to-one light)
      See Also:
        Constant Field Values

    - #### ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY_LIGHT

          static final int ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY_LIGHT

      Vocabulary icon identifiers: Association (many-to-many light)
      See Also:
        Constant Field Values

    - #### VOCABULARY_SOURCE_OE

          static final java.lang.String VOCABULARY_SOURCE_OE

      Vocabulary source OpenEdge.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### addAssociation

          IAssociationEnd addAssociation(AssociationParameters aAssociationParameters)

      Add a new association to the Vocabulary as specified in an AssociationParameters instance.
      Parameters:
        `AssociationParameters` - AssociationParameters describing new association to be added.
      Returns:
        IAssociationEnd representing association end added or `null` if unsuccessful.

    - #### addAttribute

          IAttribute addAttribute(IEntity aIEntity)

      Add a new attribute to the specified entity.
      Parameters:
        `IEntity` - Entity to which new attribute should be added.
      Returns:
        IAttribute representing attribute added or `null` if unsuccessful.

    - #### addAttribute

          IAttribute addAttribute(IEntity aIEntity,
                                IAttribute attributeSource,
                                java.lang.String attributeName)

      Add a new attribute to the specified entity, copied from the supplied attribute.
      Parameters:
        `IEntity` - Entity to which new attribute should be added.
        `IAttribute` - Source Attribute to copy in the added Attribute.
        `String` - attributeName name of the added Attribute.
      Returns:
        IAttribute representing attribute added or `null` if unsuccessful.

    - #### removeFromEntity

          java.lang.Object removeFromEntity(java.lang.Object object)

      Remove attribute or association from the entity.
      Parameters:
        `Object` - of attribute type or association type to be remove from entity.
      Returns:
        Object representing attribute or association removed or `null` if unsuccessful.

    - #### addCustomDataType

          com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType addCustomDataType()

      Add a new CustomDataType instance to the Vocabulary.
      Returns:
        CustomDataType instance.

    - #### addDatabaseProperty

          com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty addDatabaseProperty()

      Add a new DatabaseProperty instance to the Vocabulary.
      Returns:
        DatabaseProperty instance.

    - #### addDomain

          IDomain addDomain()

      Add a new domain node to the Vocabulary. The domain will be added to the Vocabulary root.
      Returns:
        IDomain representing domain node added.

    - #### addDomain

          IDomain addDomain(IDomain aIDomain)

      Add a new domain node to the Vocabulary. The domain will be added to the the specified parent IDomain.
      Parameters:
        `aIDomain` - Parent IDomain.
      Returns:
        IDomain representing domain node added.

    - #### addEntity

          IEntity addEntity()

      Add a new entity to the Vocabulary. The entity will be added to the Vocabulary root.
      Returns:
        IEntity representing entity added or `null` if unsuccessful.

    - #### addEntity

          IEntity addEntity(IDomain aIDomain)

      Add a new entity to the Vocabulary. The entity will be added to the specified parent domain.
      Parameters:
        `aIDomain` - Domain to which new entity will be added.
      Returns:
        IEntity representing entity added or `null` if unsuccessful.

    - #### addEntity

          IEntity addEntity(IDomain aIDomain,
                          IEntity aIEntitySource)

      Add a new entity to the Vocabulary and copy features from the given IEntity Source. The entity will be added to the specified parent domain or to the root if null passed.
      Parameters:
        `aIDomain` - Domain to which new entity will be added, pass null to add it to root
        `aIEntitySource` - IEntity to copy features from
      Returns:
        IEntity representing entity added or `null` if unsuccessful.

    - #### addEnumerationElement

          com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement addEnumerationElement(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType)

      Add a new Enumeration Element instance to the specified CustomDataType.
      Parameters:
        `aCustomDataType` - CustomDataType instance.
      Returns:
        Enumeration instance.

    - #### clearDatabaseMetadata

          boolean clearDatabaseMetadata(boolean abQuiet)

      Clear database metadata.
      Returns:
        `true` if the command was successful.

    - #### clearJavaClassMetadata

          boolean clearJavaClassMetadata()

      Clear Java Class Metadata.
      Returns:
        `true` if the command was successful.

    - #### createVocabulary

          IDomain createVocabulary(org.eclipse.emf.common.util.URI aURIVocabulary)

      Create a new Vocabulary Resource with the specified URI. Examples:
      platform:/LoanProject/Loan.ecore platform:/FIM/FIM.ecore
      This function creates a new Vocabulary Resource in the editing domain.
      Parameters:
        `aURIVocabulary` - New Vocabulary URI.
      Returns:
        Vocabulary root IDomain instance.

    - #### deleteVocabulary

          void deleteVocabulary()

      Delete the Vocabulary and remove its respective Resource.

    - #### findAssociation

          IAssociationEnd findAssociation(java.lang.String astrEntityName,
                                        java.lang.String astrAssociationName)

      Find association in entity matching a given name.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAttributeName` - Association name.
      Returns:
        Matching IAssociationEnd or `null` if no association could be found.

    - #### findAssociation

          IAssociationEnd findAssociation(java.lang.String astrEntityName,
                                        java.lang.String astrAssociationName,
                                        boolean abDeclaredOnly)

      Find association in entity matching a given name. This will only be for declared association ends or in the ancestors if specified by abDeclaredOnly = false.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAttributeName` - Association name.
        `abDeclaredOnly` - `true` to limit list to only declared association ends.
      Returns:
        Matching IAssociationEnd or `null` if no association could be found.

    - #### findAssociation

          IAssociationEnd findAssociation(java.lang.String astrEntityName,
                                        java.lang.String astrAssociationName,
                                        boolean abDeclaredOnly,
                                        boolean abBase)

      Find association in entity matching a given name. This will only be for declared association ends or in the ancestors if specified by abDeclaredOnly = false.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAttributeName` - Association name.
        `abDeclaredOnly` - `true` to limit list to only declared association ends.
        `abBase` - `true` if base names are supplied.
      Returns:
        Matching IAssociationEnd or `null` if no association could be found.

    - #### findXMLAssociation

          IAssociationEnd findXMLAssociation(java.lang.String astrEntityName,
                                           java.lang.String astrAssociationName)

      Find association in entity matching a given XML name.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAssociationName` - Association name.

    - #### findXMLAssociation

          IAssociationEnd findXMLAssociation(java.lang.String astrEntityName,
                                           java.lang.String astrAssociationName,
                                           java.lang.String astrQualifierType)

      Find association in entity matching a given XML name.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAssociationName` - Association name.
        `astrQualifierType` - Association qulaifier.

    - #### findAttribute

          IAttribute findAttribute(java.lang.String astrEntityName,
                                 java.lang.String astrAttributeName)

      Find first attribute in entity matching a given name.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAttributeName` - Attribute name.
      Returns:
        Matching IAttribute or `null` if no attribute could be found.

    - #### findAttribute

          IAttribute findAttribute(java.lang.String astrEntityName,
                                 java.lang.String astrAttributeName,
                                 boolean abDeclaredOnly)

      Find first attribute in entity matching a given name.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAttributeName` - Attribute name.
        `abDeclaredOnly` - `true` to limit list to only declared association ends.
      Returns:
        Matching IAttribute or `null` if no attribute could be found.

    - #### findAttribute

          IAttribute findAttribute(java.lang.String astrEntityName,
                                 java.lang.String astrAttributeName,
                                 boolean abDeclaredOnly,
                                 boolean abBase)

      Find first attribute in entity matching a given name.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAttributeName` - Attribute name.
        `abDeclaredOnly` - `true` to limit list to only declared association ends.
        `abBase` - `true` if base names are supplied.
      Returns:
        Matching IAttribute or `null` if no attribute could be found.

    - #### findXMLAttribute

          IAttribute findXMLAttribute(java.lang.String astrEntityName,
                                    java.lang.String astrAttributeName)

      Find first attribute in entity matching a given XML name.
      Parameters:
        `astrEntityName` - Entity name.
        `astrAttributeName` - Attribute name.

    - #### findCustomDataType

          com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType findCustomDataType(java.lang.String astrDataTypeName)

      Return the CustomDataType instance corresponding the specified name.
      Parameters:
        `astrDataTypeName` - Data type name.
      Returns:
        CustomDataType or `null`.

    - #### findDatabaseAccess

          com.corticon.rulesemf.canonicalvocabularymodel.DatabaseAccess findDatabaseAccess()

      Finder for DatabaseAccess instance.
      Returns:
        DatabaseAccess instance.

    - #### findCustomDataTypeByGUID

          com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType findCustomDataTypeByGUID(java.lang.String astrGUID)

      Finder to return a CustomDataType corresponding to a specified GUID.
      Parameters:
        `astrGUID` - String GUID to use as key for search.
      Returns:
        CustomDataType instance matching specified GUID or `null` if no match could be found.

    - #### findEnumerationElementByGUID

          com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement findEnumerationElementByGUID(java.lang.String astrGUID)

      Finder to return an EnumerationElement corresponding to a specified GUID.
      Parameters:
        `astrGUID` - String GUID to use as key for search.
      Returns:
        EnumerationElement instance matching specified GUID or `null` if no match could be found.

    - #### findElementByGUID

          IElement findElementByGUID(java.lang.String astrGUID)

      Finder to return a Vocabulary element corresponding to a specified GUID.
      Parameters:
        `astrGUID` - String GUID to use as key for search.
      Returns:
        IElement instance matching specified GUID or `null` if no match could be found.

    - #### findElementsBySource

          java.util.List<IElement> findElementsBySource(java.lang.String astrSource)

      Return a list of all elements in the Vocabulary that have a specified source.
      Parameters:
        `astrSource` - Source value to search for.
      Returns:
        List of Vocabulary elements matching the supplied source.

    - #### findEntity

          IEntity findEntity(java.lang.String astrEntityName)

      Find first entity matching a given name. The name can either be an unqualified entity name or a fully-qualified entity name consisting of a list of period- separated domain names followed by an entity name (similar to a Java class name).
      Parameters:
        `astrEntityName` - Entity name.
      Returns:
        IEntity instance or `null` if no match can be found.

    - #### findEntity

          IEntity findEntity(java.lang.String astrEntityName,
                           boolean abBase)

      Find first entity matching a given name. The name can either be an unqualified entity name or a fully-qualified entity name consisting of a list of period-separated domain names followed by an entity name (similar to a Java class name).
      Parameters:
        `astrEntityName` - Entity name.
        `abBase` - `true` if entity name is expressed in base form.
      Returns:
        IEntity instance or `null` if no match can be found.

    - #### findXMLEntity

          IEntity findXMLEntity(java.lang.String astrXMLEntityName)

      Find first entity with a given XML class name. The name can either be an unqualified entity name or a fully-qualified entity name consisting of a list of period- separated domain names followed by an entity name (similar to a Java class name).
      Parameters:
        `astrEntityName` - XML Entity name.
      Returns:
        IEntity instance or `null` if no match can be found.

    - #### findRoot

          IDomain findRoot()

      Finder for root IDomain instance.
      Returns:
        Root instance of IDomain.

    - #### findRootExtension

          com.corticon.rulesemf.canonicalvocabularymodel.RootExtension findRootExtension()

      Finder for RootExtension instance.
      Returns:
        RootExtension instance.

    - #### getAssociationParametersExisting

          AssociationParameters getAssociationParametersExisting(IAssociationEnd aIAssociationEnd)

      Returns an AssociationParameters instance populated with data from an existing association.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
      Returns:
        AssociationParameters instance populated from an existing association.

    - #### getAssociationParametersNew

          AssociationParameters getAssociationParametersNew(IEntity aIEntity)

      Returns an AssociationParameters instance populated with default values that are appropriate for a new association.
      Parameters:
        `IEntity` - Entity to which new association end will be added.
      Returns:
        AssociationParameters instance populated with data for the new association.

    - #### getMessageBase

          java.lang.String getMessageBase(java.lang.String astrKeyPrefix,
                                        java.lang.String astrLocalizedString)

      Return the base message corresponding to the specified bundle key.
      Specified by:
        `getMessageBase` in interface `IModelAPI`
      Parameters:
        `astrKeyPrefix` - Bundle key prefix.
        `astrLocalizedString` - Localized String.
      Returns:
        Base message from i18n bundle.

    - #### getBaseLanguageCode

          java.lang.String getBaseLanguageCode(com.corticon.rulesemf.common.LanguageCode aLanguageCode)

      Return the base locale corresponding to a specified LanguageCode instance.
      Parameters:
        `aLanguageCode` - LanguageCode instance.
      Returns:
        Base string (e.g., "English (United States)").

    - #### getBaseVocabularyString

          java.lang.String getBaseVocabularyString(java.util.List aListMultiValuedAttribute)

      Given a multi-valued attribute of VocabularyString instances, return the "base" value (index zero) if it exists in the specified list; otherwise, return `null`.
      Parameters:
        `List` - Multi-valued attribute list.
      Returns:
        Base value or `null` if no base value exists.

    - #### getCardinalitiesString

          java.lang.String getCardinalitiesString(IAssociationEnd aIAssociationEnd)

      Return the "cardinalities" string representation for a given instance of IAssociationEnd:
      1->1 (one-to-one)
      1->* (one-to-many)
      *->1 (many-to-one)
      *->* (many-to-many)
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
      Returns:
        Cardinalities string.

    - #### getDatabaseAccessDatabaseId

          java.lang.String getDatabaseAccessDatabaseId()

      Get the Database Access section Database ID.
      Returns:
        Database ID.

    - #### getDatabaseAccessJDBCDriverClass

          java.lang.String getDatabaseAccessJDBCDriverClass()

      Get the Database Access section JDBC driver class name.
      Returns:
        Database driver class name or `null`.

    - #### getDatabaseAccessDialect

          java.lang.String getDatabaseAccessDialect()

      Get the Database Access section Dialect.
      Returns:
        Hibernate Dialect `null`.

    - #### getDatabaseAccessDatabaseURL

          java.lang.String getDatabaseAccessDatabaseURL()

      Get the Database Access section Database URL.
      Returns:
        Database URL.

    - #### getDatabaseAccessUsername

          java.lang.String getDatabaseAccessUsername()

      Get the Database Access section Username.
      Returns:
        User name.

    - #### getDatabaseAccessUsernameEncrypted

          java.lang.String getDatabaseAccessUsernameEncrypted()

      Get the Database Access section Username, which is encrypted.
      Returns:
        User name.

    - #### getDatabaseAccessPassword

          java.lang.String getDatabaseAccessPassword()

      Get the Database Access section Password.
      Returns:
        Password.

    - #### getDatabaseAccessPasswordEncrypted

          java.lang.String getDatabaseAccessPasswordEncrypted()

      Get the Database Access section Password, which is encrypted.
      Returns:
        Password.

    - #### getDatabaseAccessCatalogFilter

          java.lang.String getDatabaseAccessCatalogFilter()

      Get the Database Access section Catalog Filter.
      Returns:
        Catalog Filter.

    - #### getDatabaseAccessSchemaFilter

          java.lang.String getDatabaseAccessSchemaFilter()

      Get the Database Access section Schema Filter.
      Returns:
        Schema Filter.

    - #### getDatabaseProperty

          java.lang.String getDatabaseProperty(java.lang.String astrName)

      Get the value of the specified database property.
      Parameters:
        `astrName` - name of database property.
      Returns:
        Value of database property or `null` if no such property exists.

    - #### getDatabaseDefinition

          IDatabaseDefinition getDatabaseDefinition()

      Construct and return an instance of the database definition API.
      Returns:
        Instance of IDatabaseDefinition

    - #### getDatabaseMappingAPI

          IDatabaseMappingAPI getDatabaseMappingAPI()

      Construct and return an instance of the database mapping API. The API will share the same state as *this* API.
      Returns:
        Instance of IDatabaseMappingAPI.

    - #### getDatabaseMetadataAPI

          IDatabaseMetadataAPI getDatabaseMetadataAPI()

      Construct and return an instance of the database metadata API. The API will share the same state as *this* API.
      Returns:
        Instance of IDatabaseMetadataAPI.

    - #### getJavaMappingAPI

          IJavaMappingAPI getJavaMappingAPI()

      Construct and return an instance of the Java mapping API. The API will share the same state as *this* API.
      Returns:
        Instance of IJavaMappingAPI.

    - #### getJavaMetadataAPI

          IJavaMetadataAPI getJavaMetadataAPI()

      Construct and return an instance of the Java metadata API. The API will share the same state as *this* API.
      Returns:
        Instance of IJavaMetadataAPI.

    - #### getListAttributeModes

          java.util.List getListAttributeModes()

      Return a list consisting of all attribute mode values (e.g., base, extended transient).
      Returns:
        List of attribute modes.

    - #### getListCardinalities

          java.util.List getListCardinalities(IAssociationEnd aIAssociationEnd)

      Return a list of all cardinality choices:
      1->1 (one-to-one)
      1->* (one-to-many)
      *->1 (many-to-one)
      *->* (many-to-many)
      Returns:
        List of all cardinality choices.

    - #### getListDatabaseColumnNames

          java.util.List getListDatabaseColumnNames(java.lang.String astrTableName)

      Return a list all database column names belonging to a specified database table.
      Parameters:
        `astrTableName` - Database table name.
      Returns:
        List of all column names belonging to the specified database table.

    - #### getListDatabasePropertyNames

          java.util.List getListDatabasePropertyNames()

      Return a list all database property names.
      Returns:
        List of all database property names.

    - #### getListDatabaseServerNames

          java.util.List<java.lang.String> getListDatabaseServerNames()

      Return a localized list of all database server names from the Database Definition API.
      Returns:
        Localized list of all database server names.

    - #### getListDatabaseTableNames

          java.util.List getListDatabaseTableNames()

      Return a list all database tables specified in the database metadata.
      Returns:
        List of all table names.

    - #### getListDataTypeNames

          java.util.List getListDataTypeNames()

      Return a list of attribute data type names.
      Returns:
        List of attribute data type names.

    - #### getListDataTypeNamesIncludingCustom

          java.util.List getListDataTypeNamesIncludingCustom()

      Return a list of attribute data type names including custom data type names.
      Returns:
        List of attribute data type names.

    - #### getListDataTypeNamesUnspecified

          java.util.List getListDataTypeNamesUnspecified()

      Return a list of attribute data type names including unspecified choice.
      Returns:
        List of attribute data type names.

    - #### getListEntityIdentity

          java.util.List getListEntityIdentity(IEntity aIEntity)

      Return a list of items needed to populate the entity identity combo box.
      Parameters:
        `aIEntity` - Vocabulary entity whose entity identity member names should be returned.
      Returns:
        List of attributes and role names.

    - #### getListEntityIdentity

          java.util.List getListEntityIdentity(IEntity aIEntity,
                                             boolean abBase)

      Return a list of items needed to populate the entity identity combo box.
      Parameters:
        `aIEntity` - Vocabulary entity whose entity identity member names should be returned.
        `abBase` - `true` to return base entity names.
      Returns:
        List of attributes and role names.

    - #### getListEntityNames

          java.util.List getListEntityNames()

      Return a list of fully-qualified entity names in the Vocabulary.
      Returns:
        List of all entity names (fully-qualified).

    - #### getListUnqualifiedEntityNames

          java.util.List getListUnqualifiedEntityNames()

      Return a list of unqualified entity names in the Vocabulary. This will be used in certain types of validation that prohibit names matching the unqualified Entity Names
      Returns:
        List of all entity names (unqualified).

    - #### getListEntityNames

          java.util.List getListEntityNames(boolean abIncludeBlankItem)

      Return a list of fully-qualified entity names in the Vocabulary. Optionally include a blank item.
      Parameters:
        `abIncludeBlank` - `true` to include blank item.
      Returns:
        List of all entity names (fully-qualified).

    - #### getListEntityNames

          java.util.List getListEntityNames(boolean abIncludeBlankItem,
                                          boolean abBase)

      Return a list of fully-qualified entity names in the Vocabulary. Optionally include a blank item. The returned list may consist of either base names or localized names.
      Parameters:
        `abIncludeBlank` - `true` to include blank item.
        `abBase` - `true` to return base entity names.
      Returns:
        List of all entity names (fully-qualified).

    - #### getListFieldNullValue

          java.util.List getListFieldNullValue()

      Return a list of JPOX field:null-value choices.
      Returns:
        List of JPOX field:null-value choices.

    - #### getListEnumeration

          java.util.List getListEnumeration(IAttribute aIAttribute,
                                          boolean abUnspecified,
                                          boolean abNull,
                                          boolean abIncludeCustomDataTypeNames)

      Return a list from the custom data type enumeration identified by the specified attribute facade.
      Parameters:
        `aIAttribute` - Attribute for which enumeration is to be returned.
        `abUnspecified` - `true` to include unspecified (blank) value in list.
        `abNull` - `true` to include null value in list.
        `abIncludeCustomDataTypeNames` - Include custom data type names.
      Returns:
        List of enumeration items or `null`.

    - #### getListFieldValueStrategies

          java.util.List getListFieldValueStrategies(IAttribute aIAttribute)

      Return a list of JPOX field:value-strategy choices.
      Returns:
        List of JPOX field:value-strategy choices.

    - #### getListIdentityStrategies

          java.util.List getListIdentityStrategies()

      Return a list of identity strategies.
      Returns:
        List of identity strategies.

    - #### getListJavaClassNames

          java.util.List getListJavaClassNames(java.lang.String astrPackageName)

      Return a list of java class names belonging to the specified fully-qualified package name.
      Parameters:
        `astrPackageName` - Fully-qualified package name.
      Returns:
        List of all java class names.

    - #### getListJavaObjectGetMethods

          java.util.List getListJavaObjectGetMethods(IAttribute aIAttribute)

      Return a list consisting of java object get method names.
      Parameters:
        `aIAttribute` - Attribute for which method names are to be returned.
      Returns:
        List of object get method names.

    - #### getListJavaObjectSetMethods

          java.util.List getListJavaObjectSetMethods(IAttribute aIAttribute)

      Return a list consisting of java object set method names.
      Parameters:
        `aIAttribute` - Attribute for which method names are to be returned.
      Returns:
        List of object set method names.

    - #### getListJavaObjectGetMethods

          java.util.List getListJavaObjectGetMethods(IAssociationEnd aIAssociationEnd)

      Return a list consisting of java object get method names.
      Parameters:
        `aIAssociationEnd` - Association end for which method names are to be returned.
      Returns:
        List of object get method names.

    - #### getListJavaObjectSetMethods

          java.util.List getListJavaObjectSetMethods(IAssociationEnd aIAssociaitonEnd)

      Return a list consisting of java object set method names.
      Parameters:
        `aIAssociationEnd` - Association end for which method names are to be returned.
      Returns:
        List of object set method names.

    - #### getListJavaObjectFieldNames

          java.util.List getListJavaObjectFieldNames(IAssociationEnd aIAssociationEnd)

      Return a list consisting of java object field names.
      Parameters:
        `aIAssociationEnd` - Association end for which field names are to be returned.
      Returns:
        List of object field names.

    - #### getListJavaObjectFieldNames

          java.util.List getListJavaObjectFieldNames(IAttribute aIAttribute)

      Return a list consisting of java object field names.
      Parameters:
        `aIAttribute` - Attribute for which field names are to be returned.
      Returns:
        List of object field names.

    - #### getListJavaPackages

          java.util.List getListJavaPackages()

      Return a list of java package names (imported java object metadata).
      Returns:
        List of all packages imported.

    - #### getListLocaleNames

          java.util.List getListLocaleNames()

      Return a localized list of all locale names (typically used to populate the "Locale" drop-down list in the Localization view.
      Returns:
        List of all locale names.

    - #### getListJoinExpressions

          java.util.List getListJoinExpressions(IAssociationEnd aIAssociationEnd)

      Get all valid join expressions for a given association end from database metadata. The returned list can be used to construct a list of all possible choices (e.g., to populate a combo box).
      Parameters:
        `aIAssociationEnd` - IAssociationEnd instance.
      Returns:
        List of valid join expressions (empty if no join expressions can be ascertained).

    - #### getListNavigabilities

          java.util.List getListNavigabilities(IAssociationEnd aIAssociation)

      Return a list of all navigability choices. Example:
      Customer->order
      Bidirectional
      order<-Customer
      Parameters:
        `aIAssociation` - Association for which navigability choices should be returned.
      Returns:
        List of all navigability choices.

    - #### getListNavigabilities

          java.util.List getListNavigabilities(java.lang.String astrSourceEntityName,
                                             java.lang.String astrSourceToTargetRoleName,
                                             java.lang.String astrTargetEntityName,
                                             java.lang.String astrTargetToSourceRoleName)

      Return a list of all navigability choices. Example:
      Customer->order
      Bidirectional
      order<-Customer
      Parameters:
        `astrSourceEntityName` - Source entity name.
        `astrSourceToTargetRoleName` - Source-to-target role name.
        `astrTargetEntityName` - Target entity name.
        `astrTargetToSourceRoleName` - Target-to-source role name.
      Returns:
        List of all navigability choices.

    - #### getListVersionStrategies

          java.util.List getListVersionStrategies()

      Return a list of version strategies.
      Returns:
        List of version strategies.

    - #### getListTrueFalse

          java.util.List getListTrueFalse()

      Return a list consisting of values "true" and "false" choices.
      Returns:
        List of choices "true" and "false".

    - #### getListTrueFalseUnspecified

          java.util.List getListTrueFalseUnspecified()

      Return a list consisting of values "true", "false" and unspecified choices.
      Returns:
        List of choices "true" and "false".

    - #### getLocalDataType

          java.lang.String getLocalDataType(IAttribute aIAttribute)

      Return the data type string localized for display, taking custom data types into account.
      Parameters:
        `IAttribute` - Attribute whose data type is to be returned.
      Returns:
        Data type string localized for display.

    - #### getLocalLanguageCode

          java.lang.String getLocalLanguageCode(com.corticon.rulesemf.common.LanguageCode aLanguageCode)

      Return the localized locale corresponding to a specified LanguageCode instance.
      Parameters:
        `aLanguageCode` - LanguageCode instance.
      Returns:
        Localized string (e.g., "English (United States)").

    - #### getLocalString

          java.lang.String getLocalString(java.lang.String astrKeyPrefix,
                                        java.lang.String astrBaseString)

      Convenience method to get the localized value for a corresponding base value.
      Parameters:
        `astrKeyPrefix` - Bundle key prefix.
        `astrBaseString` - Base string.
      Returns:
        Localized string.

    - #### getNavigabilitySourceToTarget

          java.lang.String getNavigabilitySourceToTarget(java.lang.String astrEntityName,
                                                       java.lang.String astrRoleName)

      Format and return source-to-target navigability string.
      Parameters:
        `astrEntityName` - Entity name.
        `astrRoleName` - Role name.
      Returns:
        Source-to-target navigability string.

    - #### getNavigabilityTargetToSource

          java.lang.String getNavigabilityTargetToSource(java.lang.String astrEntityName,
                                                       java.lang.String astrRoleName)

      Format and return target-to-source navigability string.
      Parameters:
        `astrEntityName` - Entity name.
        `astrRoleName` - Role name.
      Returns:
        Target-to-source navigability string.

    - #### getNavigabilityString

          java.lang.String getNavigabilityString(IAssociationEnd aIAssociationEnd)

      Return the "navigability" string representation for a given instance of IAssociationEnd. Examples:
      Customer->order Bidirectional
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
      Returns:
        Navigability string.

    - #### getNavigabilityBidirectional

          java.lang.String getNavigabilityBidirectional()

      Format and return bidirectional navigability string.
      Returns:
        Bidirectional navigability string.

    - #### getNewRoleName

          java.lang.String getNewRoleName(IEntity aIEntitySource,
                                        IEntity aIEntityTarget)

      Return a guaranteed-unique role name. The default name is the decapitalized name of the target class. If that role name is already in use, a sequence number will be added starting with 1.
      Parameters:
        `aIEntitySource` - Entity to which new role will be added.
        `aIEntityTarget` - Target entity for new association.
      Returns:
        New unique role name.

    - #### getNewAttributeName

          java.lang.String getNewAttributeName(IEntity aIEntity)

      Return a guaranteed-unique attribute name of the form Attribute_ where is a sequence number (starting with 1).
      Parameters:
        `aIEntity` - Entity to which attribute is to be added.
      Returns:
        New unique attribute name.

    - #### getNewEntityName

          java.lang.String getNewEntityName(IDomain aIDomain)

      Return a guaranteed-unique entity name of the form Entity_ where is a sequence number (starting with 1).
      Parameters:
        `aIDomain` - Domain to which new Entity will be added or `null` for unqualified.
      Returns:
        New unique entity name.

    - #### getNewDomainName

          java.lang.String getNewDomainName(IDomain aIDomain)

      Return a guaranteed-unique domain name of the form Domain_ where is a sequence number (starting with 1).
      Parameters:
        `aIDomain` - Domain to which new domain will be added or `null` for unqualified.
      Returns:
        New unique entity name.

    - #### getNewVocabularyName

          java.lang.String getNewVocabularyName(org.eclipse.emf.common.util.URI aURIContainer)

      Given the URI of a container in the storage system, create a new unique Vocabulary name using sequence numbers if necessary.
      Example (URI shown is for Eclipse platform):
      platform:/Examples/TradeAllocation/FIM
      Parameters:
        `aURIContainer` - URI of container.
      Returns:
        New Vocabulary name.

    - #### getOperationsModelAPI

          IOperationsModelAPI getOperationsModelAPI()

      Return an instance of the Operations model API with its state set identically to *this* API.
      Returns:
        Instance of IOperationsModelAPI.

    - #### getOperatorName

          java.lang.String getOperatorName(java.lang.String astrOperatorID,
                                         boolean abBase)

      Get the base or localized operator name corresponding to the specified operator ID.
      Parameters:
        `astrOperatorID` - Operator ID.
        `abBase` - `true` to return base value.
      Returns:
        Base or localized operator name.

    - #### getToolTip

          java.lang.String getToolTip(IElement lIElement)

      Get the tool tip for the specified Vocabulary node.
      Parameters:
        `aIElement` - Element for which tool-tip should be returned.
      Returns:
        String Tool tip or `null` if none.

    - #### getDomain

          IDomain getDomain()

      Deprecated.
      Get domain corresponding to this vocabulary
      Returns:

    - #### getVocabularyDomainHierarchy

          java.lang.String getVocabularyDomainHierarchy(IEntity aIEntity)

      Given an IEntity, return a localized Vocabulary domain hierarchy for that entity. If the entity is in the Vocabulary root, this method will return `null`
      Parameters:
        `aIEntity` - Vocabulary entity.
      Returns:
        Localized domain hierarchy.

    - #### getVocabularyElementChildren

          java.util.List getVocabularyElementChildren(java.lang.Object aObject,
                                                    boolean abExpandAssociations,
                                                    boolean abIncludeInherited,
                                                    boolean abSort)

      Get a list of children of the specified Vocabulary element. The list of children returned will be influenced by parameters abExpandAssociations and abIncludeInherited.
      Parameters:
        `aObject` - Either Resource or instance of IElement.
        `abExpandAssociations` - `true` to return children of association nodes.
        `abIncludeInherited` - `true` to include inherited attributes and associations.
        `abSort` - `true` to sort attributes and associations.
      Returns:
        List of child Vocabulary elements.

    - #### getVocabularyElementIcon

          int getVocabularyElementIcon(IElement aIElement)

      Given an IElement instance, return an integer constant corresponding to the icon to be displayed in the Vocabulary tree viewer (e.g., IVocabularyModelAPI.ICON_VOCABULARY_ENTITY).
      Parameters:
        `aIElement` - IElement instance.
      Returns:
        Integer constant specifying which icon should be displayed.

    - #### getVocabularyElementName

          java.lang.String getVocabularyElementName(IElement aIElement)

      Given an IElement, return a localized element name. The localization is a function of the API locale.
      Parameters:
        `aIElement` - Vocabulary element (e.g., IEntity, IAttribute, IAssociationEnd).
      Returns:
        Localized element name.

    - #### getVocabularyElementName

          java.lang.String getVocabularyElementName(IElement aIElement,
                                                  boolean abBase)

      Given an IElement, return an element name.
      Parameters:
        `aIElement` - Vocabulary element (e.g., IEntity, IAttribute, IAssociationEnd).
        `abBase` - `true` to return base name.
      Returns:
        Element name.

    - #### getVocabularyElementNameHierarchy

          java.lang.String getVocabularyElementNameHierarchy(IElement aIElement,
                                                           boolean abBase)

      Given an IElement return a unique base or localized name for that element.
      Parameters:
        `aIElement` - Vocabulary element.
        `abBase` - `true` to return base value.
      Returns:
        Base or Localized name hierarchy.

    - #### getVocabularyElementNameBase

          java.lang.String getVocabularyElementNameBase(IElement aIElement)

      Deprecated. Use getVocabularyElementName(aIElement, abBase) instead.
      Given an IElement, return the base element name.
      Parameters:
        `aIElement` - Vocabulary element (e.g., IEntity, IAttribute, IAssociationEnd).
      Returns:
        Base element name.

    - #### getVocabularyElementParent

          java.lang.Object getVocabularyElementParent(java.lang.Object aObject)

      Return the parent of the specified Vocabulary element.
      Parameters:
        `aObject` - Vocabulary element for which parent is to be returned.
      Returns:
        Parent element instance.

    - #### getVocabularyElementSuffix

          java.lang.String getVocabularyElementSuffix(IEntity aIEntity,
                                                    boolean abAssociationFormat,
                                                    boolean abBase)

      Return the appropriate localized suffix for a given Vocabulary entity. The suffix will include a domain qualifier if the entity name is ambiguous within the Vocabulary. This method can return two formats depending on specified parameters:
      Standard format ::com.corticon::
      Association format (Order ::com.corticon::)
      Parameters:
        `aIEntity` - Entity to use.
        `abAssociationFormat` - `true` to return association format suffix.
        `abBase` - `true` to return base form.
      Returns:
        Suffix or empty string if no suffix is required.

    - #### getVocabularyElementText

          java.lang.String getVocabularyElementText(IElement aObject,
                                                  boolean abBase)

      Given a Vocabulary element (facade), return text to be displayed adjacent to the specified node in the Vocabulary tree.
      Parameters:
        `aIElement` - Vocabulary element.
        `abBase` - `true` to return base value.
      Returns:
        Text display for Vocabulary node.

    - #### hasDatabase

          boolean hasDatabase(IElement aIElement)

      Return true if the Vocabulary Element is database bound and should be represented in the tree with a database decoration.
      Parameters:
        `IElement` - Vocabulary element to test.
      Returns:
        `true` if Vocabulary element should have database decoration.

    - #### hasModified

          boolean hasModified(IElement aIElement)

      Return true if the Vocabulary Element is should be be represented with the modified icon decoration.
      Parameters:
        `IElement` - Vocabulary element to test.
      Returns:
        `true` if Vocabulary element has been modified.

    - #### hasErrors

          boolean hasErrors(IElement aIElement,
                          boolean abRecursive)

      Return true if the Vocabulary Element has any validation errors.
      Parameters:
        `IElement` - Vocabulary element to test for errors.
        `abRecursive` - `true` to check recursively for errors in child nodes.
      Returns:
        `true` if Vocabulary element has any errors.

    - #### hasErrors

          boolean hasErrors(IElement aIElement,
                          boolean abRecursive,
                          boolean abIncludeInherited)

      Return true if the Vocabulary Element has any validation errors.
      Parameters:
        `IElement` - Vocabulary element to test for errors.
        `abRecursive` - `true` to check recursively for errors in child nodes.
        `abIncludeInherited` - `true` to consider errors in inherited nodes.
      Returns:
        `true` if Vocabulary element has any errors.

    - #### hasWarnings

          boolean hasWarnings(IElement aIElement,
                            boolean abRecursive)

      Return true if the Vocabulary Element has any validation warnings.
      Parameters:
        `IElement` - Vocabulary element to test for warnings.
        `abRecursive` - `true` to check recursively for warnings in child nodes.
      Returns:
        `true` if Vocabulary element has any warnings.

    - #### hasWarnings

          boolean hasWarnings(IElement aIElement,
                            boolean abRecursive,
                            boolean abIncludeInherited)

      Return true if the Vocabulary Element has any validation warnings.
      Parameters:
        `IElement` - Vocabulary element to test for warnings.
        `abRecursive` - `true` to check recursively for warnings in child nodes.
        `abIncludeInherited` - `true` to consider errors in inherited nodes.
      Returns:
        `true` if Vocabulary element has any warnings.

    - #### importDatabaseMetadata

          boolean importDatabaseMetadata(boolean abQuiet)

      Import the database metadata.
      Returns:
        `true` if the command was successful.

    - #### importJavaMetadata

          java.lang.String importJavaMetadata(java.util.Collection<java.lang.String> acollClassNames,
                                            java.util.List<java.lang.String> alistPaths,
                                            IProgressDelegate aIProgressDelegate)

      Import Java class metadata corresponding to a collection of fully-qualified class names.
      Parameters:
        `acollClassNames` - Collection (String) of fully-qualified class names to import.
        `alistPaths` - List of paths to JARs or class folders.
        `aIProgressDelegate` - Progress delegate or `null` if no progress reporting is needed.
      Returns:
        List of errors detected during import or `null`.

    - #### isDatabaseAccessEnabled

          boolean isDatabaseAccessEnabled()

      Method to return an indication of whether database access support is enabled.
      Returns:
        `true` if database access is enabled.

    - #### isDatabaseAccessSpecified

          boolean isDatabaseAccessSpecified()

      Method to return an indication of whether the Vocabulary has database access fields specified.
      Returns:
        `true` if the Vocabulary has database access fields specified.

    - #### isEnabledAddAssociation

          boolean isEnabledAddAssociation(Selection aSelection)

      Determine whether Add Association function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledAddAttribute

          boolean isEnabledAddAttribute(Selection aSelection)

      Determine whether Add Attribute function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledAddDomain

          boolean isEnabledAddDomain(Selection aSelection)

      Determine whether Add Domain function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledAddEntity

          boolean isEnabledAddEntity(Selection aSelection)

      Determine whether Add Entity function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledClearDatabaseMetadata

          boolean isEnabledClearDatabaseMetadata()

      Determine whether Clear Database Metadata function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledClearJavaClassMetadata

          boolean isEnabledClearJavaClassMetadata()

      Determine whether Clear Java Class Metadata function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledImportDatabaseMetadata

          boolean isEnabledImportDatabaseMetadata()

      Determine whether Import Database Metadata function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledExportDatabaseAccessProperties

          boolean isEnabledExportDatabaseAccessProperties()

      Determine whether Export Database Access Properties function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledImportJavaClassMetadata

          boolean isEnabledImportJavaClassMetadata(Selection aSelection)

      Determine whether Import Java Class Metadata function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledLocalize

          boolean isEnabledLocalize()

      Determine whether Localize function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEntityNameAlreadyUsed

          boolean isEntityNameAlreadyUsed(java.lang.String astrEntityName)

      Determine whether this name matches any entity name in the Vocabulary. The search includes entities in all domains, and covers all supported locales.
      Parameters:
        `astrName` - Name to test.
      Returns:
        `true` if the name matches any entity name.

    - #### isRoleNameUsed

          boolean isRoleNameUsed(IEntity aIEntity,
                               java.lang.String astrRoleName)

      Determine whether the specified role name is currently in use within the specified Entity.
      Parameters:
        `aIEntity` - Entity to which new role will potentially be added.
        `astrRoleName` - Role name to be tested.
      Returns:
        `true` if role name is in use.

    - #### isVocabularyElementInherited

          boolean isVocabularyElementInherited(IElement aIElement)

      Deprecated. Use isVocabularyElementNameLightGray instead.
      Determine whether the specified Vocabulary element is inherited.
      Parameters:
        `aIElement` - Vocabulary element to be tested.
      Returns:
        `true` if element is inherited.

    - #### isVocabularyElementNameLightGray

          boolean isVocabularyElementNameLightGray(IElement aIElement)

      Determine whether the specified Vocabulary element name should be rendered in light gray text. For associations, only qualified ones are shown in light gray.
      Parameters:
        `aIElement` - Vocabulary element to be tested.
      Returns:
        `true` if element should be rendered using light gray text.

    - #### isVocabularyEntityNameUnique

          boolean isVocabularyEntityNameUnique(IEntity aIEntity,
                                             boolean abBase)

      Determine whether the name of the specified entity would be ambiguous if it were not for its domain qualification (i.e., the unqualified entity name is used by more than one Vocabulary entity).
      Parameters:
        `aIEntity` - Entity to test.
        `abBase` - `true` to test base values.
      Returns:
        `true` if unqualified entity name is not unique within the Vocabulary.

    - #### isInheritedFeature

          boolean isInheritedFeature(IEntity aIEntity,
                                   IElement aIElementFeature)

      Returns `true` if the given Vocabulary element (attribute or association) is an inherited feature of the specified entity.
      Parameters:
        `aIEntity` - Entity facade.
        `aIElementFeature` - Attribute or association end facade.
      Returns:
        `true` if the feature is inherited.

    - #### getFacade

          IElement getFacade(org.eclipse.emf.ecore.ENamedElement aENamedElement)

      Return the Vocabulary facade corresponding to the specified EMF object instance. If no facade yet exists, a new facade will be created, associated with the EMF object, and returned returned.
      Parameters:
        `aENamedElement` - Named element for which facade should be returned.
      Returns:
        IElement (facade) instance.

    - #### makeVocabularyBoolean

          com.corticon.rulesemf.canonicalvocabularymodel.VocabularyBoolean makeVocabularyBoolean(java.lang.String astrValue)

      Factory method to create a valid, manually-created VocabularyBoolean from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        Valid, manually-created instance or `null`.

    - #### makeVocabularyDataType

          com.corticon.rulesemf.canonicalvocabularymodel.VocabularyDataType makeVocabularyDataType(java.lang.String astrValue)

      Factory method to create a valid, manually-created VocabularyDataType from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        Valid, manually-created instance or `null`.

    - #### makeVocabularyExpression

          com.corticon.rulesemf.canonicalvocabularymodel.VocabularyExpression makeVocabularyExpression(java.lang.String astrValue)

      Factory method to create a valid, manually-created VocabularyExpression from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        Valid, manually-created instance or `null`.

    - #### makeVocabularyString

          com.corticon.rulesemf.canonicalvocabularymodel.VocabularyString makeVocabularyString(java.lang.String astrValue)

      Factory method to create a valid, manually-created VocabularyString from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        Valid, manually-created instance or `null`.

    - #### makeVocabularyValueSet

          com.corticon.rulesemf.canonicalvocabularymodel.VocabularyValueSet makeVocabularyValueSet(java.lang.String astrValue)

      Factory method to create a valid, manually-created VocabularyValueSet from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        Valid, manually-created instance or `null`.

    - #### removeCustomDataType

          boolean removeCustomDataType(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType)

      Remove the specified CustomDataType from the list.
      Parameters:
        `aCustomDataType` - CustomDataType to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeDatabaseProperty

          boolean removeDatabaseProperty(com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty aDatabaseProperty)

      Remove a DatabaseProperty from the list.
      Parameters:
        `aDatabaseProperty` - Database property to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeEnumerationElement

          boolean removeEnumerationElement(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                         com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement)

      Remove an EnumerationElement from the specified CustomDataType.
      Parameters:
        `aCustomDataType` - CustomDataType instance.
        `aEnumerationElement` - EnumerationElement to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeVocabularyElement

          boolean removeVocabularyElement(IElement aIElement)

      Remove an element from the Vocabulary.
      Parameters:
        `aIElement` - IDomain, IEntity, IAttribute or IAssociationEnd to be removed.
      Returns:
        `true` if the command was successful.

    - #### renameVocabulary

          boolean renameVocabulary(org.eclipse.emf.common.util.URI aURIVocabularyNew)

      Rename the specified Vocabulary.
      Parameters:
        `aURIVocabularyNew` - New Vocabulary URI.
      Returns:
        `true` if the command was successful.

    - #### replaceAssociation

          boolean replaceAssociation(IAssociationEnd aIAssociationEnd,
                                   AssociationParameters aAssociationParameters)

      Replace (update) an existing association.
      Parameters:
        `IAssociationEnd` - Existing association end.
        `AssociationParameters` - AssociationParameters describing association to be added.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndCardinalities

          boolean setAssociationEndCardinalities(IAssociationEnd aIAssociationEnd,
                                               java.lang.String astrValue)

      Set AssociationEnd Cardinalities.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndJavaObjectFieldName

          boolean setAssociationEndJavaObjectFieldName(IAssociationEnd aIAssociationEnd,
                                                     java.lang.String astrValue)

      Set AssociationEnd Java Object Field Name.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndJavaObjectGetMethod

          boolean setAssociationEndJavaObjectGetMethod(IAssociationEnd aIAssociationEnd,
                                                     java.lang.String astrValue)

      Set AssociationEnd Java Object Get Method.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndJavaObjectSetMethod

          boolean setAssociationEndJavaObjectSetMethod(IAssociationEnd aIAssociationEnd,
                                                     java.lang.String astrValue)

      Set AssociationEnd Java Object Set Method.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndJoinExpression

          boolean setAssociationEndJoinExpression(IAssociationEnd aIAssociationEnd,
                                                java.lang.String astrValue)

      Set AssociationEnd Join Expression.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndMandatory

          boolean setAssociationEndMandatory(IAssociationEnd aIAssociationEnd,
                                           java.lang.String astrValue)

      Set AssociationEnd Mandatory.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndName

          boolean setAssociationEndName(IAssociationEnd aIAssociationEnd,
                                      java.lang.String astrValue)

      Set AssociationEnd name.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndNavigability

          boolean setAssociationEndNavigability(IAssociationEnd aIAssociationEnd,
                                              java.lang.String astrValue)

      Set AssociationEnd Navigability.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndSourceEntity

          boolean setAssociationEndSourceEntity(IAssociationEnd aIAssociationEnd,
                                              java.lang.String astrValue)

      Set AssociationEnd Source Entity.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndTargetEntity

          boolean setAssociationEndTargetEntity(IAssociationEnd aIAssociationEnd,
                                              java.lang.String astrValue)

      Set AssociationEnd Target Entity.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAssociationEndXMLPropertyName

          boolean setAssociationEndXMLPropertyName(IAssociationEnd aIAssociationEnd,
                                                 java.lang.String astrValue)

      Set AssociationEnd XML Property Name.
      Parameters:
        `aIAssociationEnd` - AssociationEnd instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeDataSubtype

          boolean setAttributeDataSubtype(IAttribute aIAttribute,
                                        java.lang.String astrValue)

      Deprecated. Subtypes are now handled as real data types (use method setAttributeDataType instead).
      Set Attribute data subtype.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeDataType

          boolean setAttributeDataType(IAttribute aIAttribute,
                                     java.lang.String astrValue)

      Set Attribute data type.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeFieldColumn

          boolean setAttributeFieldColumn(IAttribute aIAttribute,
                                        java.lang.String astrValue)

      Set Attribute field:column property.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeFieldSequence

          boolean setAttributeFieldSequence(IAttribute aIAttribute,
                                          java.lang.String astrValue)

      Set Attribute field:sequence property.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeFieldSequenceNameColumnName

          boolean setAttributeFieldSequenceNameColumnName(IAttribute aIAttribute,
                                                        java.lang.String astrValue)

      Set Attribute field:sequence-name-column-name property.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeFieldSequenceNextvalColumnName

          boolean setAttributeFieldSequenceNextvalColumnName(IAttribute aIAttribute,
                                                           java.lang.String astrValue)

      Set Attribute field:sequence-nextval-column-name property.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeFieldSequenceTableName

          boolean setAttributeFieldSequenceTableName(IAttribute aIAttribute,
                                                   java.lang.String astrValue)

      Set Attribute field:sequence-table-name property.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeFieldValueStrategy

          boolean setAttributeFieldValueStrategy(IAttribute aIAttribute,
                                               java.lang.String astrValue)

      Set Attribute field:value-strategy property.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeJavaObjectFieldName

          boolean setAttributeJavaObjectFieldName(IAttribute aIAttribute,
                                                java.lang.String astrValue)

      Set Attribute Java Object Field Name.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeJavaObjectGetMethod

          boolean setAttributeJavaObjectGetMethod(IAttribute aIAttribute,
                                                java.lang.String astrValue)

      Set Attribute Java Object Get Method.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeJavaObjectSetMethod

          boolean setAttributeJavaObjectSetMethod(IAttribute aIAttribute,
                                                java.lang.String astrValue)

      Set Attribute Java Object Set Method.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeMandatory

          boolean setAttributeMandatory(IAttribute aIAttribute,
                                      java.lang.String astrValue)

      Set Attribute mandatory flag.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeMode

          boolean setAttributeMode(IAttribute aIAttribute,
                                 java.lang.String astrValue)

      Set Attribute mode.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeName

          boolean setAttributeName(IAttribute aIAttribute,
                                 java.lang.String astrValue)

      Set Attribute name.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributePossibleValues

          boolean setAttributePossibleValues(IAttribute aIAttribute,
                                           java.lang.String astrValue)

      Deprecated. This method should only be used by Corticon. This is used in the 4.x to 5.0 Vocabulary conversion
      Set Attribute possible values set.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributePossibleValueSetName

          boolean setAttributePossibleValueSetName(IAttribute aIAttribute,
                                                 java.lang.String astrValue)

      Set Attribute possible values set name.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeXMLNamespace

          boolean setAttributeXMLNamespace(IAttribute aIAttribute,
                                         java.lang.String astrValue)

      Set Attribute XML Namespace.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setAttributeXMLPropertyName

          boolean setAttributeXMLPropertyName(IAttribute aIAttribute,
                                            java.lang.String astrValue)

      Set Attribute XML Property Name.
      Parameters:
        `aIAttribute` - Attribute instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setDatabasePropertyName

          boolean setDatabasePropertyName(com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty aDatabaseProperty,
                                        java.lang.String astrValue)

      Sets the database property name.
      Parameters:
        `aDatabaseProperty` - DatabaseProperty instance to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setDatabasePropertyValue

          boolean setDatabasePropertyValue(com.corticon.rulesemf.canonicalvocabularymodel.DatabaseProperty aDatabaseProperty,
                                         java.lang.String astrValue)

      Sets the database property value.
      Parameters:
        `aDatabaseProperty` - DatabaseProperty instance to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setDatabaseAccessDatabaseId

          boolean setDatabaseAccessDatabaseId(java.lang.String astrValue)

      Set the Database Access section Database ID.
      Parameters:
        `astrValue` - Database ID.
      Returns:
        `true` if the command was successful.

    - #### setDatabaseAccessDatabaseURL

          boolean setDatabaseAccessDatabaseURL(java.lang.String astrValue)

      Set the Database Access section Database URL.
      Parameters:
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setDatabaseAccessUsername

          boolean setDatabaseAccessUsername(java.lang.String astrValue)

      Set the Database Access section Username.
      Parameters:
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setDatabaseAccessPassword

          boolean setDatabaseAccessPassword(java.lang.String astrValue)

      Set the Database Access section Password.
      Parameters:
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setDatabaseAccessCatalogFilter

          boolean setDatabaseAccessCatalogFilter(java.lang.String astrValue)

      Set the Database Access section catalog filter.
      Parameters:
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setDatabaseAccessSchemaFilter

          boolean setDatabaseAccessSchemaFilter(java.lang.String astrValue)

      Set the Database Access section schema filter.
      Parameters:
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setCurrentVocabularyElement

          boolean setCurrentVocabularyElement(IElement aIElement)

      Set the "current" Vocabulary element.
      Parameters:
        `aIElement` - Vocabulary element currently selected.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeName

          boolean setCustomDataTypeName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                      java.lang.String astrValue)

      Sets the Custom data type name.
      Parameters:
        `aCustomDataType` - Custom data type to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeBaseDataType

          boolean setCustomDataTypeBaseDataType(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                              java.lang.String astrValue)

      Sets the Custom data type base data type.
      Parameters:
        `aCustomDataType` - Custom data type to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeEnumeration

          boolean setCustomDataTypeEnumeration(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                             java.lang.String astrValue)

      Sets the Custom data type enumeration flag.
      Parameters:
        `aCustomDataType` - Custom data type to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeConstraint

          boolean setCustomDataTypeConstraint(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                            java.lang.String astrValue)

      Sets the Custom data type constraint expression.
      Parameters:
        `aCustomDataType` - Custom data type to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeLookupTableName

          boolean setCustomDataTypeLookupTableName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                                 java.lang.String astrValue)

      Sets the Custom data type lookup table name.
      Parameters:
        `aCustomDataType` - Custom data type to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeLookupLabelsColumn

          boolean setCustomDataTypeLookupLabelsColumn(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                                    java.lang.String astrValue)

      Sets the Custom data type lookup labels column.
      Parameters:
        `aCustomDataType` - Custom data type to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeLookupValuesColumn

          boolean setCustomDataTypeLookupValuesColumn(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                                    java.lang.String astrValue)

      Sets the Custom data type lookup values column.
      Parameters:
        `aCustomDataType` - Custom data type to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setEnumerationLabel

          boolean setEnumerationLabel(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement,
                                    java.lang.String astrValue)

      Sets the Enumeration label.
      Parameters:
        `aEnumerationElement` - Enumeration element to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setEnumerationValue

          boolean setEnumerationValue(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement,
                                    java.lang.String astrValue)

      Sets the Enumeration value.
      Parameters:
        `aEnumerationElement` - Enumeration element to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setDomainName

          boolean setDomainName(IDomain aIDomain,
                              java.lang.String astrValue)

      Set Domain name.
      Parameters:
        `aIDomain` - Domain instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityClassTable

          boolean setEntityClassTable(IEntity aIEntity,
                                    java.lang.String astrValue)

      Set Entity class:table property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastoreCaching

          boolean setEntityDatastoreCaching(IEntity aIEntity,
                                          java.lang.String astrValue)

      Set Entity datastore caching indicator.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastorePersistent

          boolean setEntityDatastorePersistent(IEntity aIEntity,
                                             java.lang.String astrValue)

      Set Entity datastore-persistent indicator.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastoreIdentityColumn

          boolean setEntityDatastoreIdentityColumn(IEntity aIEntity,
                                                 java.lang.String astrValue)

      Set Entity datastore-identity:column property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastoreIdentitySequence

          boolean setEntityDatastoreIdentitySequence(IEntity aIEntity,
                                                   java.lang.String astrValue)

      Set Entity datastore-identity:sequence property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastoreIdentitySequenceNameColumnName

          boolean setEntityDatastoreIdentitySequenceNameColumnName(IEntity aIEntity,
                                                                 java.lang.String astrValue)

      Set Entity datastore-identity:sequence-name-column-name property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastoreIdentitySequenceNextvalColumnName

          boolean setEntityDatastoreIdentitySequenceNextvalColumnName(IEntity aIEntity,
                                                                    java.lang.String astrValue)

      Set Entity datastore-identity:sequence-nextval-column-name property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastoreIdentitySequenceTableName

          boolean setEntityDatastoreIdentitySequenceTableName(IEntity aIEntity,
                                                            java.lang.String astrValue)

      Set Entity datastore-identity:sequence-table-name property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityDatastoreIdentityStrategy

          boolean setEntityDatastoreIdentityStrategy(IEntity aIEntity,
                                                   java.lang.String astrValue)

      Set Entity datastore-identity:strategy property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityIdentity

          boolean setEntityIdentity(IEntity aIEntity,
                                  java.lang.String astrValue)

      Set Entity Identity.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityJavaClassName

          boolean setEntityJavaClassName(IEntity aIEntity,
                                       java.lang.String astrValue)

      Set Entity Java Class name.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityJavaPackage

          boolean setEntityJavaPackage(IEntity aIEntity,
                                     java.lang.String astrValue)

      Set Entity Java Package.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityName

          boolean setEntityName(IEntity aIEntity,
                              java.lang.String astrValue)

      Set Entity name.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntitySupertypes

          boolean setEntitySupertypes(IEntity aIEntity,
                                    java.lang.String astrValue)

      Set Entity Supertype(s).
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntitySupertypes

          boolean setEntitySupertypes(IEntity aIEntity,
                                    java.util.List aListEntities)

      Set Entity Supertype(s) given a list of IEntity facades.
      Parameters:
        `aIEntity` - Entity instance.
        `aListEntities` - List of IEntity facade supertypes.
      Returns:
        `true` if the command was successful.

    - #### setEntityVersionColumn

          boolean setEntityVersionColumn(IEntity aIEntity,
                                       java.lang.String astrValue)

      Set Entity version:column property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityVersionStrategy

          boolean setEntityVersionStrategy(IEntity aIEntity,
                                         java.lang.String astrValue)

      Set Entity version:strategy property.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityXMLNamespace

          boolean setEntityXMLNamespace(IEntity aIEntity,
                                      java.lang.String astrValue)

      Set Entity XML Namespace.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setEntityXMLClassName

          boolean setEntityXMLClassName(IEntity aIEntity,
                                      java.lang.String astrValue)

      Set Entity XML Class name.
      Parameters:
        `aIEntity` - Entity instance.
        `astrValue` - Value.
      Returns:
        `true` if the command was successful.

    - #### setGUID

          boolean setGUID(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                        java.lang.String astrGUID)

      Set the optional GUID associated with the specified custom data type.
      Parameters:
        `aCustomDataType` - CustomDataType whose GUID is to be set.
        `astrValue` - String value of GUID.
      Returns:
        `true` if the command was successful.

    - #### setGUID

          boolean setGUID(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumeratonElement,
                        java.lang.String astrGUID)

      Set the optional GUID associated with the specified enumeration element.
      Parameters:
        `aEnumerationElement` - EnumerationElement whose GUID is to be set.
        `astrValue` - String value of GUID.
      Returns:
        `true` if the command was successful.

    - #### setGUID

          boolean setGUID(IElement aIElement,
                        java.lang.String astrGUID)

      Set the optional GUID associated with this element.
      Parameters:
        `aIElement` - IDomain, IEntity, IAttribute or IAssociationEnd instance.
        `astrValue` - String value of GUID.
      Returns:
        `true` if the command was successful.

    - #### setLocalizationCustomDataTypeName

          boolean setLocalizationCustomDataTypeName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                                  int aiLocalizationIndex,
                                                  java.lang.String astrText)

      Given a CustomDataType instance, update the specified localized custom data type name.
      Parameters:
        `aCustomDataType` - Custom data type whose localized name is to be updated.
        `aiLocalizationIndex` - Index of localization to be updated.
        `astrText` - Localized text.
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationEnumerationLabel

          boolean setLocalizationEnumerationLabel(com.corticon.rulesemf.canonicalvocabularymodel.EnumerationElement aEnumerationElement,
                                                int aiLocalizationIndex,
                                                java.lang.String astrText)

      Given a EnumerationElement instance, update the specified localized enumeration label.
      Parameters:
        `aEnumerationElement` - Enumeration element whose label is to be updated.
        `aiLocalizationIndex` - Index of localization to be updated.
        `astrText` - Localized text.
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationVocabularyElementName

          boolean setLocalizationVocabularyElementName(IElement aIElement,
                                                     int aiLocalizationIndex,
                                                     java.lang.String astrText)

      Given a Vocabulary element, update the specified localized element name.
      Parameters:
        `aIElement` - Vocabulary element whose localized name is to be updated.
        `aiLocalizationIndex` - Index of localization to be updated.
        `astrText` - Localized text.
      Returns:
        `true` if the set command was successful.

    - #### setSource

          boolean setSource(IElement aIElement,
                          java.lang.String astrSource)

      Set the optional "source" associated with this element.
      Parameters:
        `aIElement` - IDomain, IEntity, IAttribute or IAssociationEnd instance.
        `astrValue` - String value of source.
      Returns:
        `true` if the command was successful.

    - #### setVocabularyElementName

          boolean setVocabularyElementName(IElement aIElement,
                                         java.lang.String astrValue)

      Set the localized Vocabulary element name according to Native Tongue editing rules.
      Parameters:
        `aIElement` - Element whose name is to be set.
        `astrValue` - Localized element name.
      Returns:
        `true` if the set command was successful.

    - #### testDatabaseConnection

          void testDatabaseConnection()

      Test the database connection using the database access properties and display a message box if the connection is valid.

    - #### makeDomain

          IDomain makeDomain(org.eclipse.emf.ecore.EPackage aEPackage)

      Factory method to create a new IDomain facade from a given EPackage.
      Parameters:
        `aEPackage` - EPackage for which IDomain should be created.
      Returns:
        IDomain instance.

    - #### generateBusinessObjects

          java.util.HashMap generateBusinessObjects()

      Generate a set of basic Business Objects from the Vocabulary
      Returns:
        HashMap

    - #### getConvertedDomainName

          java.lang.String getConvertedDomainName(java.lang.String astrDomainName)

      This method will take in the astrDomainName and verify that it conforms to Corticon's naming standards. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `astrDomainName` - Domain name.
      Returns:
        Converted domain name.

    - #### getNextAvailableDomainName

          java.lang.String getNextAvailableDomainName(IDomain aIDomain,
                                                    java.lang.String astrDomainName)

      This method will take in the astrDomainName that is passed in and verify that it is unique within a passed in Domain. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIDomain` - Parent domain.
        `astrDomainName` - Name of domain to be made unique.
      Returns:
        Unique domain name.

    - #### getNextAvailableConvertedDomainName

          java.lang.String getNextAvailableConvertedDomainName(IDomain aIDomain,
                                                             java.lang.String astrDomainName)

      This method will take in the astrDomainName and call into getConvertedDomainName(String) and getNextAvailableDomainName(IDomain, String) for the name that was passed into this method. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIDomain` - Parent domain.
        `astrDomainName` - Name of domain to be made unique.
      Returns:
        Unique converted domain name.

    - #### getConvertedEntityName

          java.lang.String getConvertedEntityName(java.lang.String astrEntityName)

      This method will take in the astrEntityName and verify that it conforms to Corticon's naming standards. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `astrEntityName` - Entity name.
      Returns:
        Converted entity name.

    - #### getNextAvailableEntityName

          java.lang.String getNextAvailableEntityName(IDomain aIDomain,
                                                    java.lang.String astrEntityName)

      This method will take in the astrEntityName that is passed in and verify that it is unique within a passed in Domain. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIDomain` - Parent domain.
        `astrEntityName` - Name of entity to be made unique.
      Returns:
        Unique entity name.

    - #### getNextAvailableConvertedEntityName

          java.lang.String getNextAvailableConvertedEntityName(IDomain aIDomain,
                                                             java.lang.String astrEntityName)

      This method will take in the astrEntityName and call into getConvertedEntityName(String) and getNextAvailableEntityName(IDomain, String) for the name that was passed into this method. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIDomain` - Parent domain.
        `astrEntityName` - Name of entity to be made unique.
      Returns:
        Unique converted entity name.

    - #### getConvertedAttributeName

          java.lang.String getConvertedAttributeName(java.lang.String astrAttributeName)

      This method will take in the astrAttributeName and verify that it conforms to Corticon's naming standards. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `astrAttributeName` - Attribute name.
      Returns:
        Converted attribute name.

    - #### getNextAvailableAttributeName

          java.lang.String getNextAvailableAttributeName(IEntity aIEntity,
                                                       java.lang.String astrAttributeName)

      This method will take in the astrAttributeName that is passed in and verify that it is unique in this Entity. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIEntity` - Parent entity.
        `astrAttributeName` - Attribute name to be made unique.
      Returns:
        Unique attribute name.

    - #### getNextAvailableConvertedAttributeName

          java.lang.String getNextAvailableConvertedAttributeName(IEntity aIEntity,
                                                                java.lang.String astrAttributeName)

      This method will take in the astrAttributeName and call into getConvertedAttributeName(String) and getNextAvailableAttributeName(IEntity, String) for the name that was passed into this method. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIEntity` - Parent entity.
        `astrAttributeName` - Attribute name to be made unique.
      Returns:
        Unique converted attribute name.

    - #### getConvertedCustomDataTypeName

          java.lang.String getConvertedCustomDataTypeName(java.lang.String astrCustomDataTypeName)

      This method will take in the astrCustomDataTypeName and verify that it conforms to Corticon's naming standards. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aCustomDataType` - Custom data type name.
      Returns:
        Converted custom data type name.

    - #### getNextAvailableCustomDataTypeName

          java.lang.String getNextAvailableCustomDataTypeName(java.lang.String astrCustomDataTypeName)

      This method will take in the astrCustomDataTypeName that is passed in and verify that it is unique. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aCustomDataType` - Custom data type name.
      Returns:
        Unique custom data type name.

    - #### getNextAvailableConvertedCustomDataTypeName

          java.lang.String getNextAvailableConvertedCustomDataTypeName(java.lang.String astrCustomDataTypeName)

      This method will take in the astrCustomDataTypeName and call into getConvertedCustomDataTypeName(String) and getNextAvailableCustomDataTypeName(String) for the name that was passed into this method. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aCustomDataType` - Custom data type name.
      Returns:
        Unique converted custom data type name.

    - #### getConvertedCustomDataTypeLabelName

          java.lang.String getConvertedCustomDataTypeLabelName(java.lang.String astrCustomDataTypeLabelName)

      This method will take in the astrCustomDataTypeLabelName and verify that it conforms to Corticon's naming standards. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `astrCustomDataTypeLabelName` - Custom data type label name.
      Returns:
        Converted custom data type label name.

    - #### getNextAvailableCustomDataTypeLabelName

          java.lang.String getNextAvailableCustomDataTypeLabelName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                                                 java.lang.String astrCustomDataTypeLabelName)

      This method will take in the astrCustomDataTypeLabelName that is passed in and verify that it is unique within a passed in custom data type. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aCustomDataType` - Parent custom data type.
        `astrCustomDataTypeLabelName` - Custom data type label name.
      Returns:
        Unique custom data type label name.

    - #### getNextAvailableConvertedCustomDataTypeLabelName

          java.lang.String getNextAvailableConvertedCustomDataTypeLabelName(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType,
                                                                          java.lang.String astrCustomDataTypeLabelName)

      This method will take in the astrCustomDataTypeLabelName and call into getConvertedCustomDataTypeLabelName(String) and getNextAvailableCustomDataTypeLabelName(CustomDataType, String) for the passed in name. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aCustomDataType` - Parent custom data type.
        `astrCustomDataTypeLabelName` - Custom data type label name.
      Returns:
        Unique converted custom data type label name.

    - #### getConvertedRoleName

          java.lang.String getConvertedRoleName(java.lang.String astrRoleName)

      This method will take in the astrRoleName and verify that it conforms to Corticon's naming standards. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `astrRoleName` - Association role name.
      Returns:
        Converted association role name.

    - #### getCurrentVocabularyElement

          IElement getCurrentVocabularyElement()

      Get the "current" Vocabulary element.
      Returns:
        IElement currently selected or `null`.

    - #### getNextAvailableRoleName

          java.lang.String getNextAvailableRoleName(IEntity aIEntitySource,
                                                  IEntity aIEntityTarget,
                                                  java.lang.String astrRoleName)

      This method will take in the astrRoleName that is passed in and verify that it is unique within a passed in source entity. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIEntitySource` - Source entity of association.
        `aIEntityTarget` - Target entity of association.
        `astrRoleName` - Association role name.
      Returns:
        Unique association role name.

    - #### getNextAvailableConvertedRoleName

          java.lang.String getNextAvailableConvertedRoleName(IEntity aIEntitySource,
                                                           IEntity aIEntityTarget,
                                                           java.lang.String astrRoleName)

      This method will take in the astrRoleName and call into getConvertedRoleName(String) and getNextAvailableRoleName(IEntity, IEntity, String) for the passed in role name. If it is unique, that same name will be returned. If it isn't, this method will return a new recommended name that the client should use.
      Parameters:
        `aIEntitySource` - Source entity of association.
        `aIEntityTarget` - Target entity of association.
        `astrRoleName` - Association role name.
      Returns:
        Unique converted association role name.

    - #### getNextAvailableConvertedAssociationParamaters

          AssociationParameters getNextAvailableConvertedAssociationParamaters(AssociationParameters aAssociationParameters)

      This method will take in the aAssociationParameters and call into getConvertedName(String) and getNextAvailableAliasName(String)for each role name of the association. A new copy of the aAssociationParameters will be returned. If there is an issue then a copied aAssociationParameters will be updated and returned to the caller.
      Parameters:
        `aAssociationParameters` - AssociationParameters instance.
      Returns:
        Updated AssociationParameters instance.

    - #### convertNameIfExtendedOperatorOrOperationsName

          java.lang.String convertNameIfExtendedOperatorOrOperationsName(java.lang.String astrName)

      This method will take in astrName and determine if it is a name that matches an existing Extended Operator or Operations Tree name. If so, the astrName will be converted by adding an "_" to the front of the name.
      Parameters:
        `astrName` - Name to be tested.
      Returns:
        String Updated name.

    - #### isNameExtendedOperatorOrOperationsName

          boolean isNameExtendedOperatorOrOperationsName(java.lang.String astrName)

      Check to see if this particular name conflicts with a name in the Operations Tree or an Extended Operator
      Parameters:
        `astrName` - Name to be tested.
      Returns:
        boolean `true` if name appears in operations tree.

    - #### getEnumerationLabelBasedOnValue

          java.lang.String getEnumerationLabelBasedOnValue(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aDataType,
                                                         java.lang.String astrValue)

      Query the service to receive the label associated with a value of a enumeration type of type name.
      Parameters:
        `astrName` -
        `astrValue` -
      Returns:
        The registered value associated with the label under enumeration type of type name, or null if value and/or name is invalid

    - #### getDefaultIdentityStrategy

          java.lang.String getDefaultIdentityStrategy(IEntity aIEntity)

      Return a default identity strategy for a given entity
      Parameters:
        `aIEntity` -
      Returns:
        String the identity strategy if can be determined or `null` otherwise

    - #### getDefaultIdentityStrategy

          java.lang.String getDefaultIdentityStrategy(java.lang.String astrDefaultIdentityStrategyType)

      Return a default identity strategy for a given identity strategy type
      Parameters:
        `astrDefaultIdentityStrategyType` -
      Returns:
        String the identity strategy if can be determined or `null` otherwise

    - #### getDefaultIdentityStrategyType

          java.lang.String getDefaultIdentityStrategyType(IEntity aIEntity)

      Return a default identity strategy type for a given entity
      Parameters:
        `aIEntity` -
      Returns:
        String the identity strategy type if can be determined or `null` otherwise

    - #### isReadOnlyModeSupported

          boolean isReadOnlyModeSupported()

      Check if the Read Only mode is supported by the database
      Returns:
        boolean `true` if the Read Only mode is supported by the database;

    - #### isCreateUpdateSchemaSupported

          boolean isCreateUpdateSchemaSupported()

      Check if the Create/Update schema is supported by the database
      Returns:
        boolean `true` if the Create/Update schema is supported by the database;

    - #### isEnabledReadOnlyReadWrite

          boolean isEnabledReadOnlyReadWrite()

      Check if the the Vocabulary is set in ReadOnly or ReadWrite mode
      Returns:
        boolean `true` if the Vocabulary is set to Read Only

    - #### setEnabledReadOnlyReadWrite

          void setEnabledReadOnlyReadWrite(boolean abReadOnlyReadWrite)

      Set Vocabulary ReadOnly or ReadWrite mode
      Parameters:
        `boolean` - `true` set the Vocabulary to Read Only (true) or Read Write (false)

Copyright © 2005-2013 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.